

static int
dissect_hi2_OBJECT_IDENTIFIER(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_object_identifier(implicit_tag, actx, tree, tvb, offset, hf_index, NULL);

  return offset;
}


static const value_string hi2_T_iRIversion_vals[] = {
  {   2, "version2" },
  {   3, "version3" },
  {   4, "version4" },
  {   5, "version5" },
  {   6, "version6" },
  {   7, "version7" },
  {   8, "lastVersion" },
  { 0, NULL }
};


static int
dissect_hi2_T_iRIversion(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}



static int
dissect_hi2_LawfulInterceptionIdentifier(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_1_8(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_1_5(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_1_25(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const value_string hi2_T_iP_type_vals[] = {
  {   0, "iPV4" },
  {   1, "iPV6" },
  { 0, NULL }
};


static int
dissect_hi2_T_iP_type(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_4_16(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}



static int
dissect_hi2_IA5String_SIZE_7_45(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_restricted_string(implicit_tag, BER_UNI_TAG_IA5String,
                                            actx, tree, tvb, offset, hf_index,
                                            NULL);

  return offset;
}


static const value_string hi2_IP_value_vals[] = {
  {   1, "iPBinaryAddress" },
  {   2, "iPTextAddress" },
  { 0, NULL }
};

static const ber_choice_t IP_value_choice[] = {
  {   1, &hf_hi2_iPBinaryAddress , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_4_16 },
  {   2, &hf_hi2_iPTextAddress   , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_IA5String_SIZE_7_45 },
  { 0, NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_IP_value(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 IP_value_choice, hf_index, ett_hi2_IP_value,
                                 NULL);

  return offset;
}


static const value_string hi2_T_iP_assignment_vals[] = {
  {   1, "static" },
  {   2, "dynamic" },
  {   3, "notKnown" },
  { 0, NULL }
};


static int
dissect_hi2_T_iP_assignment(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}


static const ber_sequence_t IPAddress_sequence[] = {
  { &hf_hi2_iP_type         , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_T_iP_type },
  { &hf_hi2_iP_value        , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_IP_value },
  { &hf_hi2_iP_assignment   , BER_CLASS_CON, 3, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_T_iP_assignment },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_IPAddress(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   IPAddress_sequence, hf_index, ett_hi2_IPAddress);

  return offset;
}


static const value_string hi2_Network_Element_Identifier_vals[] = {
  {   1, "e164-Format" },
  {   2, "x25-Format" },
  {   3, "iP-Format" },
  {   4, "dNS-Format" },
  {   5, "iP-Address" },
  { 0, NULL }
};

static const ber_choice_t Network_Element_Identifier_choice[] = {
  {   1, &hf_hi2_e164_Format     , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_25 },
  {   2, &hf_hi2_x25_Format      , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_25 },
  {   3, &hf_hi2_iP_Format       , BER_CLASS_CON, 3, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_25 },
  {   4, &hf_hi2_dNS_Format      , BER_CLASS_CON, 4, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_25 },
  {   5, &hf_hi2_iP_Address      , BER_CLASS_CON, 5, BER_FLAGS_IMPLTAG, dissect_hi2_IPAddress },
  { 0, NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_Network_Element_Identifier(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 Network_Element_Identifier_choice, hf_index, ett_hi2_Network_Element_Identifier,
                                 NULL);

  return offset;
}


static const ber_sequence_t Network_Identifier_sequence[] = {
  { &hf_hi2_operator_Identifier, BER_CLASS_CON, 0, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_5 },
  { &hf_hi2_network_Element_Identifier, BER_CLASS_CON, 1, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_Network_Element_Identifier },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_Network_Identifier(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   Network_Identifier_sequence, hf_index, ett_hi2_Network_Identifier);

  return offset;
}


static const ber_sequence_t CommunicationIdentifier_sequence[] = {
  { &hf_hi2_communication_Identity_Number, BER_CLASS_CON, 0, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_8 },
  { &hf_hi2_network_Identifier, BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_Network_Identifier },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_CommunicationIdentifier(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   CommunicationIdentifier_sequence, hf_index, ett_hi2_CommunicationIdentifier);

  return offset;
}



static int
dissect_hi2_GeneralizedTime(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_GeneralizedTime(implicit_tag, actx, tree, tvb, offset, hf_index);

  return offset;
}


static const value_string hi2_T_winterSummerIndication_vals[] = {
  {   0, "notProvided" },
  {   1, "winterTime" },
  {   2, "summerTime" },
  { 0, NULL }
};


static int
dissect_hi2_T_winterSummerIndication(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}


static const ber_sequence_t LocalTimeStamp_sequence[] = {
  { &hf_hi2_generalizedTime , BER_CLASS_CON, 0, BER_FLAGS_IMPLTAG, dissect_hi2_GeneralizedTime },
  { &hf_hi2_winterSummerIndication, BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_T_winterSummerIndication },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_LocalTimeStamp(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   LocalTimeStamp_sequence, hf_index, ett_hi2_LocalTimeStamp);

  return offset;
}



static int
dissect_hi2_UTCTime(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_UTCTime(implicit_tag, actx, tree, tvb, offset, hf_index);

  return offset;
}


static const value_string hi2_TimeStamp_vals[] = {
  {   0, "localTime" },
  {   1, "utcTime" },
  { 0, NULL }
};

static const ber_choice_t TimeStamp_choice[] = {
  {   0, &hf_hi2_localTime       , BER_CLASS_CON, 0, BER_FLAGS_IMPLTAG, dissect_hi2_LocalTimeStamp },
  {   1, &hf_hi2_utcTime         , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_UTCTime },
  { 0, NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_TimeStamp(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 TimeStamp_choice, hf_index, ett_hi2_TimeStamp,
                                 NULL);

  return offset;
}


static const value_string hi2_T_intercepted_Call_Direct_vals[] = {
  {   0, "not-Available" },
  {   1, "originating-Target" },
  {   2, "terminating-Target" },
  { 0, NULL }
};


static int
dissect_hi2_T_intercepted_Call_Direct(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}


static const value_string hi2_Intercepted_Call_State_vals[] = {
  {   1, "idle" },
  {   2, "setUpInProcess" },
  {   3, "connected" },
  { 0, NULL }
};


static int
dissect_hi2_Intercepted_Call_State(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_3(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_5_7(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}



static int
dissect_hi2_INTEGER_0_1023(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                                NULL);

  return offset;
}



static int
dissect_hi2_INTEGER_0_16383(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                                NULL);

  return offset;
}



static int
dissect_hi2_INTEGER_0_65535(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                                NULL);

  return offset;
}



static int
dissect_hi2_INTEGER(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                                NULL);

  return offset;
}


static const ber_sequence_t T_ms_Loc_sequence[] = {
  { &hf_hi2_mcc             , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_INTEGER_0_1023 },
  { &hf_hi2_mnc             , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_INTEGER_0_16383 },
  { &hf_hi2_lai             , BER_CLASS_CON, 3, BER_FLAGS_IMPLTAG, dissect_hi2_INTEGER_0_65535 },
  { &hf_hi2_ci              , BER_CLASS_CON, 4, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_INTEGER },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_T_ms_Loc(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   T_ms_Loc_sequence, hf_index, ett_hi2_T_ms_Loc);

  return offset;
}


static const value_string hi2_TetraLocation_vals[] = {
  {   1, "ms-Loc" },
  {   2, "ls-Loc" },
  { 0, NULL }
};

static const ber_choice_t TetraLocation_choice[] = {
  {   1, &hf_hi2_ms_Loc          , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_T_ms_Loc },
  {   2, &hf_hi2_ls_Loc          , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_INTEGER },
  { 0, NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_TetraLocation(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 TetraLocation_choice, hf_index, ett_hi2_TetraLocation,
                                 NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_6(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}



static int
dissect_hi2_PrintableString_SIZE_7_10(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_restricted_string(implicit_tag, BER_UNI_TAG_PrintableString,
                                            actx, tree, tvb, offset, hf_index,
                                            NULL);

  return offset;
}



static int
dissect_hi2_PrintableString_SIZE_8_11(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_restricted_string(implicit_tag, BER_UNI_TAG_PrintableString,
                                            actx, tree, tvb, offset, hf_index,
                                            NULL);

  return offset;
}


static const value_string hi2_MapDatum_vals[] = {
  {   0, "wGS84" },
  {   1, "wGS72" },
  {   2, "eD50" },
  { 0, NULL }
};


static int
dissect_hi2_MapDatum(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}



static int
dissect_hi2_INTEGER_0_359(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                                NULL);

  return offset;
}


static const ber_sequence_t T_geoCoordinates_sequence[] = {
  { &hf_hi2_latitude        , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_PrintableString_SIZE_7_10 },
  { &hf_hi2_longitude       , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_PrintableString_SIZE_8_11 },
  { &hf_hi2_mapDatum        , BER_CLASS_CON, 3, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_MapDatum },
  { &hf_hi2_azimuth         , BER_CLASS_CON, 4, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_INTEGER_0_359 },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_T_geoCoordinates(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   T_geoCoordinates_sequence, hf_index, ett_hi2_T_geoCoordinates);

  return offset;
}



static int
dissect_hi2_PrintableString_SIZE_10(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_restricted_string(implicit_tag, BER_UNI_TAG_PrintableString,
                                            actx, tree, tvb, offset, hf_index,
                                            NULL);

  return offset;
}



static int
dissect_hi2_PrintableString_SIZE_7(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_restricted_string(implicit_tag, BER_UNI_TAG_PrintableString,
                                            actx, tree, tvb, offset, hf_index,
                                            NULL);

  return offset;
}


static const ber_sequence_t T_utmCoordinates_sequence[] = {
  { &hf_hi2_utm_East        , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_PrintableString_SIZE_10 },
  { &hf_hi2_utm_North       , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_PrintableString_SIZE_7 },
  { &hf_hi2_mapDatum        , BER_CLASS_CON, 3, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_MapDatum },
  { &hf_hi2_azimuth         , BER_CLASS_CON, 4, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_INTEGER_0_359 },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_T_utmCoordinates(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   T_utmCoordinates_sequence, hf_index, ett_hi2_T_utmCoordinates);

  return offset;
}



static int
dissect_hi2_PrintableString_SIZE_13(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_restricted_string(implicit_tag, BER_UNI_TAG_PrintableString,
                                            actx, tree, tvb, offset, hf_index,
                                            NULL);

  return offset;
}


static const ber_sequence_t T_utmRefCoordinates_sequence[] = {
  { &hf_hi2_utmref_string   , BER_CLASS_UNI, BER_UNI_TAG_PrintableString, BER_FLAGS_NOOWNTAG, dissect_hi2_PrintableString_SIZE_13 },
  { &hf_hi2_mapDatum        , BER_CLASS_UNI, BER_UNI_TAG_ENUMERATED, BER_FLAGS_OPTIONAL|BER_FLAGS_NOOWNTAG, dissect_hi2_MapDatum },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_T_utmRefCoordinates(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   T_utmRefCoordinates_sequence, hf_index, ett_hi2_T_utmRefCoordinates);

  return offset;
}



static int
dissect_hi2_OCTET_STRING(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const value_string hi2_GSMLocation_vals[] = {
  {   1, "geoCoordinates" },
  {   2, "utmCoordinates" },
  {   3, "utmRefCoordinates" },
  {   4, "wGS84Coordinates" },
  { 0, NULL }
};

static const ber_choice_t GSMLocation_choice[] = {
  {   1, &hf_hi2_geoCoordinates  , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_T_geoCoordinates },
  {   2, &hf_hi2_utmCoordinates  , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_T_utmCoordinates },
  {   3, &hf_hi2_utmRefCoordinates, BER_CLASS_CON, 3, BER_FLAGS_IMPLTAG, dissect_hi2_T_utmRefCoordinates },
  {   4, &hf_hi2_wGS84Coordinates, BER_CLASS_CON, 4, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING },
  { 0, NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_GSMLocation(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 GSMLocation_choice, hf_index, ett_hi2_GSMLocation,
                                 NULL);

  return offset;
}


static const value_string hi2_T_latitudeSign_vals[] = {
  {   0, "north" },
  {   1, "south" },
  { 0, NULL }
};


static int
dissect_hi2_T_latitudeSign(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}



static int
dissect_hi2_INTEGER_0_8388607(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                                NULL);

  return offset;
}



static int
dissect_hi2_INTEGER_M8388608_8388607(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                                NULL);

  return offset;
}


static const ber_sequence_t GeographicalCoordinates_sequence[] = {
  { &hf_hi2_latitudeSign    , BER_CLASS_UNI, BER_UNI_TAG_ENUMERATED, BER_FLAGS_NOOWNTAG, dissect_hi2_T_latitudeSign },
  { &hf_hi2_latitude_01     , BER_CLASS_UNI, BER_UNI_TAG_INTEGER, BER_FLAGS_NOOWNTAG, dissect_hi2_INTEGER_0_8388607 },
  { &hf_hi2_longitude_01    , BER_CLASS_UNI, BER_UNI_TAG_INTEGER, BER_FLAGS_NOOWNTAG, dissect_hi2_INTEGER_M8388608_8388607 },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_GeographicalCoordinates(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   GeographicalCoordinates_sequence, hf_index, ett_hi2_GeographicalCoordinates);

  return offset;
}


static const ber_sequence_t GA_Point_sequence[] = {
  { &hf_hi2_geographicalCoordinates, BER_CLASS_UNI, BER_UNI_TAG_SEQUENCE, BER_FLAGS_NOOWNTAG, dissect_hi2_GeographicalCoordinates },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_GA_Point(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   GA_Point_sequence, hf_index, ett_hi2_GA_Point);

  return offset;
}



static int
dissect_hi2_INTEGER_0_127(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                                NULL);

  return offset;
}


static const ber_sequence_t GA_PointWithUnCertainty_sequence[] = {
  { &hf_hi2_geographicalCoordinates, BER_CLASS_UNI, BER_UNI_TAG_SEQUENCE, BER_FLAGS_NOOWNTAG, dissect_hi2_GeographicalCoordinates },
  { &hf_hi2_uncertaintyCode , BER_CLASS_UNI, BER_UNI_TAG_INTEGER, BER_FLAGS_NOOWNTAG, dissect_hi2_INTEGER_0_127 },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_GA_PointWithUnCertainty(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   GA_PointWithUnCertainty_sequence, hf_index, ett_hi2_GA_PointWithUnCertainty);

  return offset;
}


static const ber_sequence_t GA_Polygon_item_sequence[] = {
  { &hf_hi2_geographicalCoordinates, BER_CLASS_UNI, BER_UNI_TAG_SEQUENCE, BER_FLAGS_NOOWNTAG, dissect_hi2_GeographicalCoordinates },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_GA_Polygon_item(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   GA_Polygon_item_sequence, hf_index, ett_hi2_GA_Polygon_item);

  return offset;
}


static const ber_sequence_t GA_Polygon_sequence_of[1] = {
  { &hf_hi2_GA_Polygon_item , BER_CLASS_UNI, BER_UNI_TAG_SEQUENCE, BER_FLAGS_NOOWNTAG, dissect_hi2_GA_Polygon_item },
};

static int
dissect_hi2_GA_Polygon(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence_of(implicit_tag, actx, tree, tvb, offset,
                                      GA_Polygon_sequence_of, hf_index, ett_hi2_GA_Polygon);

  return offset;
}


static const value_string hi2_UMTSLocation_vals[] = {
  {   1, "point" },
  {   2, "pointWithUnCertainty" },
  {   3, "polygon" },
  { 0, NULL }
};

static const ber_choice_t UMTSLocation_choice[] = {
  {   1, &hf_hi2_point           , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_GA_Point },
  {   2, &hf_hi2_pointWithUnCertainty, BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_GA_PointWithUnCertainty },
  {   3, &hf_hi2_polygon         , BER_CLASS_CON, 3, BER_FLAGS_IMPLTAG, dissect_hi2_GA_Polygon },
  { 0, NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_UMTSLocation(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 UMTSLocation_choice, hf_index, ett_hi2_UMTSLocation,
                                 NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_7(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const ber_sequence_t Location_sequence[] = {
  { &hf_hi2_e164_Number     , BER_CLASS_CON, 1, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_25 },
  { &hf_hi2_globalCellID    , BER_CLASS_CON, 2, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_5_7 },
  { &hf_hi2_tetraLocation   , BER_CLASS_CON, 3, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_TetraLocation },
  { &hf_hi2_rAI             , BER_CLASS_CON, 4, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_6 },
  { &hf_hi2_gsmLocation     , BER_CLASS_CON, 5, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_GSMLocation },
  { &hf_hi2_umtsLocation    , BER_CLASS_CON, 6, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_UMTSLocation },
  { &hf_hi2_sAI             , BER_CLASS_CON, 7, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_7 },
  { &hf_hi2_oldRAI          , BER_CLASS_CON, 8, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_6 },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_Location(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   Location_sequence, hf_index, ett_hi2_Location);

  return offset;
}


static const value_string hi2_T_party_Qualifier_vals[] = {
  {   0, "originating-Party" },
  {   1, "terminating-Party" },
  {   2, "forwarded-to-Party" },
  {   3, "gPRS-Target" },
  { 0, NULL }
};


static int
dissect_hi2_T_party_Qualifier(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_8(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_1_15(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_3_8(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const value_string hi2_CallingPartyNumber_vals[] = {
  {   1, "iSUP-Format" },
  {   2, "dSS1-Format" },
  {   3, "mAP-Format" },
  { 0, NULL }
};

static const ber_choice_t CallingPartyNumber_choice[] = {
  {   1, &hf_hi2_iSUP_Format     , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_25 },
  {   2, &hf_hi2_dSS1_Format     , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_25 },
  {   3, &hf_hi2_mAP_Format      , BER_CLASS_CON, 3, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_25 },
  { 0, NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_CallingPartyNumber(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 CallingPartyNumber_choice, hf_index, ett_hi2_CallingPartyNumber,
                                 NULL);

  return offset;
}


static const value_string hi2_CalledPartyNumber_vals[] = {
  {   1, "iSUP-Format" },
  {   2, "mAP-Format" },
  {   3, "dSS1-Format" },
  { 0, NULL }
};

static const ber_choice_t CalledPartyNumber_choice[] = {
  {   1, &hf_hi2_iSUP_Format     , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_25 },
  {   2, &hf_hi2_mAP_Format      , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_25 },
  {   3, &hf_hi2_dSS1_Format     , BER_CLASS_CON, 3, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_25 },
  { 0, NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_CalledPartyNumber(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 CalledPartyNumber_choice, hf_index, ett_hi2_CalledPartyNumber,
                                 NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_1_9(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const ber_sequence_t T_partyIdentity_sequence[] = {
  { &hf_hi2_imei            , BER_CLASS_CON, 1, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_8 },
  { &hf_hi2_tei             , BER_CLASS_CON, 2, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_15 },
  { &hf_hi2_imsi            , BER_CLASS_CON, 3, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_3_8 },
  { &hf_hi2_callingPartyNumber, BER_CLASS_CON, 4, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_CallingPartyNumber },
  { &hf_hi2_calledPartyNumber, BER_CLASS_CON, 5, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_CalledPartyNumber },
  { &hf_hi2_msISDN          , BER_CLASS_CON, 6, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_9 },
  { &hf_hi2_e164_Format     , BER_CLASS_CON, 7, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_25 },
  { &hf_hi2_sip_uri         , BER_CLASS_CON, 8, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING },
  { &hf_hi2_tel_url         , BER_CLASS_CON, 9, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_T_partyIdentity(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   T_partyIdentity_sequence, hf_index, ett_hi2_T_partyIdentity);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_1_256(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const ber_sequence_t ISUP_parameters_set_of[1] = {
  { &hf_hi2_ISUP_parameters_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_ISUP_parameters(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 ISUP_parameters_set_of, hf_index, ett_hi2_ISUP_parameters);

  return offset;
}


static const ber_sequence_t DSS1_parameters_codeset_0_set_of[1] = {
  { &hf_hi2_DSS1_parameters_codeset_0_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_DSS1_parameters_codeset_0(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 DSS1_parameters_codeset_0_set_of, hf_index, ett_hi2_DSS1_parameters_codeset_0);

  return offset;
}


static const ber_sequence_t MAP_parameters_set_of[1] = {
  { &hf_hi2_MAP_parameters_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_MAP_parameters(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 MAP_parameters_set_of, hf_index, ett_hi2_MAP_parameters);

  return offset;
}


static const ber_sequence_t Services_Information_sequence[] = {
  { &hf_hi2_iSUP_parameters , BER_CLASS_CON, 1, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_ISUP_parameters },
  { &hf_hi2_dSS1_parameters_codeset_0, BER_CLASS_CON, 2, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_DSS1_parameters_codeset_0 },
  { &hf_hi2_mAP_parameters  , BER_CLASS_CON, 3, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_MAP_parameters },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_Services_Information(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   Services_Information_sequence, hf_index, ett_hi2_Services_Information);

  return offset;
}


static const ber_sequence_t ISUP_SS_parameters_set_of[1] = {
  { &hf_hi2_ISUP_SS_parameters_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_ISUP_SS_parameters(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 ISUP_SS_parameters_set_of, hf_index, ett_hi2_ISUP_SS_parameters);

  return offset;
}


static const ber_sequence_t DSS1_SS_parameters_codeset_0_set_of[1] = {
  { &hf_hi2_DSS1_SS_parameters_codeset_0_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_DSS1_SS_parameters_codeset_0(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 DSS1_SS_parameters_codeset_0_set_of, hf_index, ett_hi2_DSS1_SS_parameters_codeset_0);

  return offset;
}


static const ber_sequence_t DSS1_SS_parameters_codeset_4_set_of[1] = {
  { &hf_hi2_DSS1_SS_parameters_codeset_4_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_DSS1_SS_parameters_codeset_4(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 DSS1_SS_parameters_codeset_4_set_of, hf_index, ett_hi2_DSS1_SS_parameters_codeset_4);

  return offset;
}


static const ber_sequence_t DSS1_SS_parameters_codeset_5_set_of[1] = {
  { &hf_hi2_DSS1_SS_parameters_codeset_5_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_DSS1_SS_parameters_codeset_5(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 DSS1_SS_parameters_codeset_5_set_of, hf_index, ett_hi2_DSS1_SS_parameters_codeset_5);

  return offset;
}


static const ber_sequence_t DSS1_SS_parameters_codeset_6_set_of[1] = {
  { &hf_hi2_DSS1_SS_parameters_codeset_6_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_DSS1_SS_parameters_codeset_6(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 DSS1_SS_parameters_codeset_6_set_of, hf_index, ett_hi2_DSS1_SS_parameters_codeset_6);

  return offset;
}


static const ber_sequence_t DSS1_SS_parameters_codeset_7_set_of[1] = {
  { &hf_hi2_DSS1_SS_parameters_codeset_7_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_DSS1_SS_parameters_codeset_7(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 DSS1_SS_parameters_codeset_7_set_of, hf_index, ett_hi2_DSS1_SS_parameters_codeset_7);

  return offset;
}


static const ber_sequence_t DSS1_SS_Invoke_Components_set_of[1] = {
  { &hf_hi2_DSS1_SS_Invoke_Components_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_DSS1_SS_Invoke_Components(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 DSS1_SS_Invoke_Components_set_of, hf_index, ett_hi2_DSS1_SS_Invoke_Components);

  return offset;
}


static const ber_sequence_t MAP_SS_Parameters_set_of[1] = {
  { &hf_hi2_MAP_SS_Parameters_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_MAP_SS_Parameters(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 MAP_SS_Parameters_set_of, hf_index, ett_hi2_MAP_SS_Parameters);

  return offset;
}


static const ber_sequence_t MAP_SS_Invoke_Components_set_of[1] = {
  { &hf_hi2_MAP_SS_Invoke_Components_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_MAP_SS_Invoke_Components(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 MAP_SS_Invoke_Components_set_of, hf_index, ett_hi2_MAP_SS_Invoke_Components);

  return offset;
}


static const ber_sequence_t Standard_Supplementary_Services_sequence[] = {
  { &hf_hi2_iSUP_SS_parameters, BER_CLASS_CON, 1, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_ISUP_SS_parameters },
  { &hf_hi2_dSS1_SS_parameters_codeset_0, BER_CLASS_CON, 2, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_DSS1_SS_parameters_codeset_0 },
  { &hf_hi2_dSS1_SS_parameters_codeset_4, BER_CLASS_CON, 3, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_DSS1_SS_parameters_codeset_4 },
  { &hf_hi2_dSS1_SS_parameters_codeset_5, BER_CLASS_CON, 4, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_DSS1_SS_parameters_codeset_5 },
  { &hf_hi2_dSS1_SS_parameters_codeset_6, BER_CLASS_CON, 5, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_DSS1_SS_parameters_codeset_6 },
  { &hf_hi2_dSS1_SS_parameters_codeset_7, BER_CLASS_CON, 6, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_DSS1_SS_parameters_codeset_7 },
  { &hf_hi2_dSS1_SS_Invoke_components, BER_CLASS_CON, 7, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_DSS1_SS_Invoke_Components },
  { &hf_hi2_mAP_SS_Parameters, BER_CLASS_CON, 8, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_MAP_SS_Parameters },
  { &hf_hi2_mAP_SS_Invoke_Components, BER_CLASS_CON, 9, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_MAP_SS_Invoke_Components },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_Standard_Supplementary_Services(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   Standard_Supplementary_Services_sequence, hf_index, ett_hi2_Standard_Supplementary_Services);

  return offset;
}


static const value_string hi2_SimpleIndication_vals[] = {
  {   0, "call-Waiting-Indication" },
  {   1, "add-conf-Indication" },
  {   2, "call-on-hold-Indication" },
  {   3, "retrieve-Indication" },
  {   4, "suspend-Indication" },
  {   5, "resume-Indication" },
  {   6, "answer-Indication" },
  { 0, NULL }
};


static int
dissect_hi2_SimpleIndication(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}



static int
dissect_hi2_SciDataMode(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const value_string hi2_Non_Standard_Supplementary_Services_item_vals[] = {
  {   1, "simpleIndication" },
  {   2, "sciData" },
  { 0, NULL }
};

static const ber_choice_t Non_Standard_Supplementary_Services_item_choice[] = {
  {   1, &hf_hi2_simpleIndication, BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_SimpleIndication },
  {   2, &hf_hi2_sciData         , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_SciDataMode },
  { 0, NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_Non_Standard_Supplementary_Services_item(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 Non_Standard_Supplementary_Services_item_choice, hf_index, ett_hi2_Non_Standard_Supplementary_Services_item,
                                 NULL);

  return offset;
}


static const ber_sequence_t Non_Standard_Supplementary_Services_set_of[1] = {
  { &hf_hi2_Non_Standard_Supplementary_Services_item, BER_CLASS_ANY/*choice*/, -1/*choice*/, BER_FLAGS_NOOWNTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_Non_Standard_Supplementary_Services_item },
};

static int
dissect_hi2_Non_Standard_Supplementary_Services(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 Non_Standard_Supplementary_Services_set_of, hf_index, ett_hi2_Non_Standard_Supplementary_Services);

  return offset;
}


static const ber_sequence_t Other_Services_set_of[1] = {
  { &hf_hi2_Other_Services_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_Other_Services(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 Other_Services_set_of, hf_index, ett_hi2_Other_Services);

  return offset;
}


static const ber_sequence_t Supplementary_Services_sequence[] = {
  { &hf_hi2_standard_Supplementary_Services, BER_CLASS_CON, 1, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_Standard_Supplementary_Services },
  { &hf_hi2_non_Standard_Supplementary_Services, BER_CLASS_CON, 2, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_Non_Standard_Supplementary_Services },
  { &hf_hi2_other_Services  , BER_CLASS_CON, 3, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_Other_Services },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_Supplementary_Services(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   Supplementary_Services_sequence, hf_index, ett_hi2_Supplementary_Services);

  return offset;
}



static int
dissect_hi2_X25Address(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const value_string hi2_DataNodeAddress_vals[] = {
  {   1, "ipAddress" },
  {   2, "x25Address" },
  { 0, NULL }
};

static const ber_choice_t DataNodeAddress_choice[] = {
  {   1, &hf_hi2_ipAddress       , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_IPAddress },
  {   2, &hf_hi2_x25Address      , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_X25Address },
  { 0, NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_DataNodeAddress(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 DataNodeAddress_choice, hf_index, ett_hi2_DataNodeAddress,
                                 NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_1_100(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_2(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const ber_sequence_t GPRS_parameters_sequence[] = {
  { &hf_hi2_pDP_address_allocated_to_the_target, BER_CLASS_CON, 1, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_DataNodeAddress },
  { &hf_hi2_aPN             , BER_CLASS_CON, 2, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_100 },
  { &hf_hi2_pDP_type        , BER_CLASS_CON, 3, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_2 },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_GPRS_parameters(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   GPRS_parameters_sequence, hf_index, ett_hi2_GPRS_parameters);

  return offset;
}


static const ber_sequence_t Services_Data_Information_sequence[] = {
  { &hf_hi2_gPRS_parameters , BER_CLASS_CON, 1, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_GPRS_parameters },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_Services_Data_Information(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   Services_Data_Information_sequence, hf_index, ett_hi2_Services_Data_Information);

  return offset;
}


static const ber_sequence_t PartyInformation_sequence[] = {
  { &hf_hi2_party_Qualifier , BER_CLASS_CON, 0, BER_FLAGS_IMPLTAG, dissect_hi2_T_party_Qualifier },
  { &hf_hi2_partyIdentity   , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_T_partyIdentity },
  { &hf_hi2_services_Information, BER_CLASS_CON, 2, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_Services_Information },
  { &hf_hi2_supplementary_Services_Information, BER_CLASS_CON, 3, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_Supplementary_Services },
  { &hf_hi2_services_Data_Information, BER_CLASS_CON, 4, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_Services_Data_Information },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_PartyInformation(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   PartyInformation_sequence, hf_index, ett_hi2_PartyInformation);

  return offset;
}


static const ber_sequence_t SET_SIZE_1_10_OF_PartyInformation_set_of[1] = {
  { &hf_hi2_partyInformation_item, BER_CLASS_UNI, BER_UNI_TAG_SEQUENCE, BER_FLAGS_NOOWNTAG, dissect_hi2_PartyInformation },
};

static int
dissect_hi2_SET_SIZE_1_10_OF_PartyInformation(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 SET_SIZE_1_10_OF_PartyInformation_set_of, hf_index, ett_hi2_SET_SIZE_1_10_OF_PartyInformation);

  return offset;
}


static const value_string hi2_CCLink_State_vals[] = {
  {   1, "setUpInProcess" },
  {   2, "callActive" },
  {   3, "callReleased" },
  {   4, "lack-of-resource" },
  { 0, NULL }
};


static int
dissect_hi2_CCLink_State(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}


static const ber_sequence_t CallContentLinkCharacteristics_sequence[] = {
  { &hf_hi2_cCLink_State    , BER_CLASS_CON, 1, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_CCLink_State },
  { &hf_hi2_release_Time    , BER_CLASS_CON, 2, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_TimeStamp },
  { &hf_hi2_release_Reason  , BER_CLASS_CON, 3, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_2 },
  { &hf_hi2_lEMF_Address    , BER_CLASS_CON, 4, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_CalledPartyNumber },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_CallContentLinkCharacteristics(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   CallContentLinkCharacteristics_sequence, hf_index, ett_hi2_CallContentLinkCharacteristics);

  return offset;
}


static const ber_sequence_t T_callContentLinkInformation_sequence[] = {
  { &hf_hi2_cCLink1Characteristics, BER_CLASS_CON, 1, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_CallContentLinkCharacteristics },
  { &hf_hi2_cCLink2Characteristics, BER_CLASS_CON, 2, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_CallContentLinkCharacteristics },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_T_callContentLinkInformation(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   T_callContentLinkInformation_sequence, hf_index, ett_hi2_T_callContentLinkInformation);

  return offset;
}


static const value_string hi2_T_nature_Of_The_intercepted_call_vals[] = {
  {   0, "gSM-ISDN-PSTN-circuit-call" },
  {   1, "gSM-SMS-Message" },
  {   2, "uUS4-Messages" },
  {   3, "tETRA-circuit-call" },
  {   4, "teTRA-Packet-Data" },
  {   5, "gPRS-Packet-Data" },
  {   6, "uMTS-circuit-call" },
  { 0, NULL }
};


static int
dissect_hi2_T_nature_Of_The_intercepted_call(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}


static const value_string hi2_T_initiator_vals[] = {
  {   0, "target" },
  {   1, "server" },
  {   2, "undefined-party" },
  { 0, NULL }
};


static int
dissect_hi2_T_initiator(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}


static const value_string hi2_T_transfer_status_vals[] = {
  {   0, "succeed-transfer" },
  {   1, "not-succeed-transfer" },
  {   2, "undefined" },
  { 0, NULL }
};


static int
dissect_hi2_T_transfer_status(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}


static const value_string hi2_T_other_message_vals[] = {
  {   0, "yes" },
  {   1, "no" },
  {   2, "undefined" },
  { 0, NULL }
};


static int
dissect_hi2_T_other_message(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_1_270(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const ber_sequence_t T_sMS_Contents_sequence[] = {
  { &hf_hi2_initiator       , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_T_initiator },
  { &hf_hi2_transfer_status , BER_CLASS_CON, 2, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_T_transfer_status },
  { &hf_hi2_other_message   , BER_CLASS_CON, 3, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_T_other_message },
  { &hf_hi2_content         , BER_CLASS_CON, 4, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_270 },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_T_sMS_Contents(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   T_sMS_Contents_sequence, hf_index, ett_hi2_T_sMS_Contents);

  return offset;
}


static const ber_sequence_t SMS_report_sequence[] = {
  { &hf_hi2_communicationIdentifier, BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_CommunicationIdentifier },
  { &hf_hi2_timeStamp       , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_TimeStamp },
  { &hf_hi2_sMS_Contents    , BER_CLASS_CON, 3, BER_FLAGS_IMPLTAG, dissect_hi2_T_sMS_Contents },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_SMS_report(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   SMS_report_sequence, hf_index, ett_hi2_SMS_report);

  return offset;
}



static int
dissect_hi2_CC_Link_Identifier(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const ber_sequence_t National_Parameters_set_of[1] = {
  { &hf_hi2_National_Parameters_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_National_Parameters(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 National_Parameters_set_of, hf_index, ett_hi2_National_Parameters);

  return offset;
}



static int
dissect_hi2_GPRSCorrelationNumber(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const value_string hi2_GPRSEvent_vals[] = {
  {   1, "pDPContextActivation" },
  {   2, "startOfInterceptionWithPDPContextActive" },
  {   4, "pDPContextDeactivation" },
  {   5, "gPRSAttach" },
  {   6, "gPRSDetach" },
  {  10, "cellOrRAUpdate" },
  {  11, "sMS" },
  {  13, "pDPContextModification" },
  { 0, NULL }
};


static int
dissect_hi2_GPRSEvent(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}



static int
dissect_hi2_GPRSOperationErrorCode(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const value_string hi2_UmtsQos_vals[] = {
  {   1, "qosMobileRadio" },
  {   2, "qosGn" },
  { 0, NULL }
};

static const ber_choice_t UmtsQos_choice[] = {
  {   1, &hf_hi2_qosMobileRadio  , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING },
  {   2, &hf_hi2_qosGn           , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING },
  { 0, NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_UmtsQos(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 UmtsQos_choice, hf_index, ett_hi2_UmtsQos,
                                 NULL);

  return offset;
}


static const value_string hi2_IMSevent_vals[] = {
  {   1, "unfilteredSIPmessage" },
  {   2, "sIPheaderOnly" },
  { 0, NULL }
};


static int
dissect_hi2_IMSevent(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_1_20(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_5_17(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const value_string hi2_LDIevent_vals[] = {
  {   1, "targetEntersIA" },
  {   2, "targetLeavesIA" },
  { 0, NULL }
};


static int
dissect_hi2_LDIevent(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}


static const ber_sequence_t T_cc_set_of[1] = {
  { &hf_hi2_cc_item         , BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING },
};

static int
dissect_hi2_T_cc(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 T_cc_set_of, hf_index, ett_hi2_T_cc);

  return offset;
}


static const ber_sequence_t IRI_to_CC_Correlation_sequence[] = {
  { &hf_hi2_cc              , BER_CLASS_CON, 0, BER_FLAGS_IMPLTAG, dissect_hi2_T_cc },
  { &hf_hi2_iri             , BER_CLASS_CON, 1, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_IRI_to_CC_Correlation(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   IRI_to_CC_Correlation_sequence, hf_index, ett_hi2_IRI_to_CC_Correlation);

  return offset;
}



static int
dissect_hi2_IRI_to_IRI_Correlation(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const ber_sequence_t T_both_IRI_CC_sequence[] = {
  { &hf_hi2_iri_CC          , BER_CLASS_CON, 0, BER_FLAGS_IMPLTAG, dissect_hi2_IRI_to_CC_Correlation },
  { &hf_hi2_iri_IRI         , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_IRI_to_IRI_Correlation },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_T_both_IRI_CC(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   T_both_IRI_CC_sequence, hf_index, ett_hi2_T_both_IRI_CC);

  return offset;
}


static const value_string hi2_CorrelationValues_vals[] = {
  {   0, "iri-to-CC" },
  {   1, "iri-to-iri" },
  {   2, "both-IRI-CC" },
  { 0, NULL }
};

static const ber_choice_t CorrelationValues_choice[] = {
  {   0, &hf_hi2_iri_to_CC       , BER_CLASS_CON, 0, BER_FLAGS_IMPLTAG, dissect_hi2_IRI_to_CC_Correlation },
  {   1, &hf_hi2_iri_to_iri      , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_IRI_to_IRI_Correlation },
  {   2, &hf_hi2_both_IRI_CC     , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_T_both_IRI_CC },
  { 0, NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_CorrelationValues(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 CorrelationValues_choice, hf_index, ett_hi2_CorrelationValues,
                                 NULL);

  return offset;
}



static int
dissect_hi2_PrintableString_SIZE_2(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_restricted_string(implicit_tag, BER_UNI_TAG_PrintableString,
                                            actx, tree, tvb, offset, hf_index,
                                            NULL);

  return offset;
}


static const ber_sequence_t National_HI2_ASN1parameters_sequence[] = {
  { &hf_hi2_countryCode     , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_PrintableString_SIZE_2 },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_National_HI2_ASN1parameters(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   National_HI2_ASN1parameters_sequence, hf_index, ett_hi2_National_HI2_ASN1parameters);

  return offset;
}


static const ber_sequence_t IRI_Parameters_sequence[] = {
  { &hf_hi2_domainID        , BER_CLASS_CON, 0, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OBJECT_IDENTIFIER },
  { &hf_hi2_iRIversion      , BER_CLASS_CON, 23, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_T_iRIversion },
  { &hf_hi2_lawfulInterceptionIdentifier, BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_LawfulInterceptionIdentifier },
  { &hf_hi2_communicationIdentifier, BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_CommunicationIdentifier },
  { &hf_hi2_timeStamp       , BER_CLASS_CON, 3, BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_TimeStamp },
  { &hf_hi2_intercepted_Call_Direct, BER_CLASS_CON, 4, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_T_intercepted_Call_Direct },
  { &hf_hi2_intercepted_Call_State, BER_CLASS_CON, 5, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_Intercepted_Call_State },
  { &hf_hi2_ringingDuration , BER_CLASS_CON, 6, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_3 },
  { &hf_hi2_conversationDuration, BER_CLASS_CON, 7, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_3 },
  { &hf_hi2_locationOfTheTarget, BER_CLASS_CON, 8, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_Location },
  { &hf_hi2_partyInformation, BER_CLASS_CON, 9, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_SET_SIZE_1_10_OF_PartyInformation },
  { &hf_hi2_callContentLinkInformation, BER_CLASS_CON, 10, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_T_callContentLinkInformation },
  { &hf_hi2_release_Reason_Of_Intercepted_Call, BER_CLASS_CON, 11, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_2 },
  { &hf_hi2_nature_Of_The_intercepted_call, BER_CLASS_CON, 12, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_T_nature_Of_The_intercepted_call },
  { &hf_hi2_serverCenterAddress, BER_CLASS_CON, 13, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_PartyInformation },
  { &hf_hi2_sMS             , BER_CLASS_CON, 14, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_SMS_report },
  { &hf_hi2_cC_Link_Identifier, BER_CLASS_CON, 15, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_CC_Link_Identifier },
  { &hf_hi2_national_Parameters, BER_CLASS_CON, 16, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_National_Parameters },
  { &hf_hi2_gPRSCorrelationNumber, BER_CLASS_CON, 18, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_GPRSCorrelationNumber },
  { &hf_hi2_gPRSevent       , BER_CLASS_CON, 20, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_GPRSEvent },
  { &hf_hi2_sgsnAddress     , BER_CLASS_CON, 21, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_DataNodeAddress },
  { &hf_hi2_gPRSOperationErrorCode, BER_CLASS_CON, 22, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_GPRSOperationErrorCode },
  { &hf_hi2_ggsnAddress     , BER_CLASS_CON, 24, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_DataNodeAddress },
  { &hf_hi2_qOS             , BER_CLASS_CON, 25, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_UmtsQos },
  { &hf_hi2_networkIdentifier, BER_CLASS_CON, 26, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_Network_Identifier },
  { &hf_hi2_sMSOriginatingAddress, BER_CLASS_CON, 27, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_DataNodeAddress },
  { &hf_hi2_sMSTerminatingAddress, BER_CLASS_CON, 28, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_DataNodeAddress },
  { &hf_hi2_iMSevent        , BER_CLASS_CON, 29, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_IMSevent },
  { &hf_hi2_sIPMessage      , BER_CLASS_CON, 30, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING },
  { &hf_hi2_servingSGSN_number, BER_CLASS_CON, 31, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_20 },
  { &hf_hi2_servingSGSN_address, BER_CLASS_CON, 32, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_5_17 },
  { &hf_hi2_ldiEvent        , BER_CLASS_CON, 34, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_LDIevent },
  { &hf_hi2_correlation     , BER_CLASS_CON, 35, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_CorrelationValues },
  { &hf_hi2_national_HI2_ASN1parameters, BER_CLASS_CON, 255, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_National_HI2_ASN1parameters },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_IRI_Parameters(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   IRI_Parameters_sequence, hf_index, ett_hi2_IRI_Parameters);

  return offset;
}


static const value_string hi2_IRIContent_vals[] = {
  {   1, "iRI-Begin-record" },
  {   2, "iRI-End-record" },
  {   3, "iRI-Continue-record" },
  {   4, "iRI-Report-record" },
  { 0, NULL }
};

static const ber_choice_t IRIContent_choice[] = {
  {   1, &hf_hi2_iRI_Begin_record, BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_IRI_Parameters },
  {   2, &hf_hi2_iRI_End_record  , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_IRI_Parameters },
  {   3, &hf_hi2_iRI_Continue_record, BER_CLASS_CON, 3, BER_FLAGS_IMPLTAG, dissect_hi2_IRI_Parameters },
  {   4, &hf_hi2_iRI_Report_record, BER_CLASS_CON, 4, BER_FLAGS_IMPLTAG, dissect_hi2_IRI_Parameters },
  { 0, NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_IRIContent(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 IRIContent_choice, hf_index, ett_hi2_IRIContent,
                                 NULL);

  return offset;
}


static const ber_sequence_t IRISequence_sequence_of[1] = {
  { &hf_hi2_IRISequence_item, BER_CLASS_ANY/*choice*/, -1/*choice*/, BER_FLAGS_NOOWNTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_IRIContent },
};

static int
dissect_hi2_IRISequence(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence_of(implicit_tag, actx, tree, tvb, offset,
                                      IRISequence_sequence_of, hf_index, ett_hi2_IRISequence);

  return offset;
}


const value_string hi2_IRIsContent_vals[] = {
  {   0, "iRIContent" },
  {   1, "iRISequence" },
  { 0, NULL }
};

static const ber_choice_t IRIsContent_choice[] = {
  {   0, &hf_hi2_iRIContent      , BER_CLASS_ANY/*choice*/, -1/*choice*/, BER_FLAGS_NOOWNTAG, dissect_hi2_IRIContent },
  {   1, &hf_hi2_iRISequence     , BER_CLASS_UNI, BER_UNI_TAG_SEQUENCE, BER_FLAGS_NOOWNTAG, dissect_hi2_IRISequence },
  { 0, NULL, 0, 0, 0, NULL }
};

int
dissect_hi2_IRIsContent(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 IRIsContent_choice, hf_index, ett_hi2_IRIsContent,
                                 NULL);

  return offset;
}

/*--- PDUs ---*/

static void dissect_IRIsContent_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_) {
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_BER, TRUE, pinfo);
  dissect_hi2_IRIsContent(FALSE, tvb, 0, &asn1_ctx, tree, hf_hi2_IRIsContent_PDU);
}

