/* Do not modify this file.                                                   */
/* It is created automatically by the ASN.1 to Wireshark dissector compiler   */
/* packet-hi2.c                                                               */
/* ../../tools/asn2wrs.py -p hi2 -c hi2.cnf -b -k -s packet-hi2-template hi2.asn */

/* Input file: packet-hi2-template.c */

#line 1 "packet-hi2-template.c"
/* packet-hi2.c
 * Routines for Wireless Certificate Extension (RFC3770)
 *  Ronnie Sahlberg 2005
 *
 * $Id: packet-hi2-template.c 27390 2009-02-07 14:33:47Z wmeier $
 *
 * Wireshark - Network traffic analyzer
 * By Gerald Combs <gerald@wireshark.org>
 * Copyright 1998 Gerald Combs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <glib.h>
#include <epan/packet.h>
#include <epan/oids.h>
#include <epan/conversation.h>
#include <epan/asn1.h>

#include <stdio.h>
#include <string.h>

#include "packet-ber.h"
#include "packet-hi2.h"
#include "packet-wlancertextn.h"
#include "packet-x509af.h"
#include "packet-x509ce.h"
#include "packet-x509sat.h"

#define PNAME  "ES 201.671 v3.1.1 hi2"
#define PSNAME "HI2OPERATIONS"
#define PFNAME "hi2"

/* Initialize the protocol and registered fields */
int proto_hi2 = -1;

/*--- Included file: packet-hi2-hf.c ---*/
#line 1 "packet-hi2-hf.c"
static int hf_hi2_IRIsContent_PDU = -1;           /* IRIsContent */
static int hf_hi2_iRIContent = -1;                /* IRIContent */
static int hf_hi2_iRISequence = -1;               /* IRISequence */
static int hf_hi2_IRISequence_item = -1;          /* IRIContent */
static int hf_hi2_iRI_Begin_record = -1;          /* IRI_Parameters */
static int hf_hi2_iRI_End_record = -1;            /* IRI_Parameters */
static int hf_hi2_iRI_Continue_record = -1;       /* IRI_Parameters */
static int hf_hi2_iRI_Report_record = -1;         /* IRI_Parameters */
static int hf_hi2_domainID = -1;                  /* OBJECT_IDENTIFIER */
static int hf_hi2_iRIversion = -1;                /* T_iRIversion */
static int hf_hi2_lawfulInterceptionIdentifier = -1;  /* LawfulInterceptionIdentifier */
static int hf_hi2_communicationIdentifier = -1;   /* CommunicationIdentifier */
static int hf_hi2_timeStamp = -1;                 /* TimeStamp */
static int hf_hi2_intercepted_Call_Direct = -1;   /* T_intercepted_Call_Direct */
static int hf_hi2_intercepted_Call_State = -1;    /* Intercepted_Call_State */
static int hf_hi2_ringingDuration = -1;           /* OCTET_STRING_SIZE_3 */
static int hf_hi2_conversationDuration = -1;      /* OCTET_STRING_SIZE_3 */
static int hf_hi2_locationOfTheTarget = -1;       /* Location */
static int hf_hi2_partyInformation = -1;          /* SET_SIZE_1_10_OF_PartyInformation */
static int hf_hi2_partyInformation_item = -1;     /* PartyInformation */
static int hf_hi2_callContentLinkInformation = -1;  /* T_callContentLinkInformation */
static int hf_hi2_cCLink1Characteristics = -1;    /* CallContentLinkCharacteristics */
static int hf_hi2_cCLink2Characteristics = -1;    /* CallContentLinkCharacteristics */
static int hf_hi2_release_Reason_Of_Intercepted_Call = -1;  /* OCTET_STRING_SIZE_2 */
static int hf_hi2_nature_Of_The_intercepted_call = -1;  /* T_nature_Of_The_intercepted_call */
static int hf_hi2_serverCenterAddress = -1;       /* PartyInformation */
static int hf_hi2_sMS = -1;                       /* SMS_report */
static int hf_hi2_cC_Link_Identifier = -1;        /* CC_Link_Identifier */
static int hf_hi2_national_Parameters = -1;       /* National_Parameters */
static int hf_hi2_gPRSCorrelationNumber = -1;     /* GPRSCorrelationNumber */
static int hf_hi2_gPRSevent = -1;                 /* GPRSEvent */
static int hf_hi2_sgsnAddress = -1;               /* DataNodeAddress */
static int hf_hi2_gPRSOperationErrorCode = -1;    /* GPRSOperationErrorCode */
static int hf_hi2_ggsnAddress = -1;               /* DataNodeAddress */
static int hf_hi2_qOS = -1;                       /* UmtsQos */
static int hf_hi2_networkIdentifier = -1;         /* Network_Identifier */
static int hf_hi2_sMSOriginatingAddress = -1;     /* DataNodeAddress */
static int hf_hi2_sMSTerminatingAddress = -1;     /* DataNodeAddress */
static int hf_hi2_iMSevent = -1;                  /* IMSevent */
static int hf_hi2_sIPMessage = -1;                /* OCTET_STRING */
static int hf_hi2_servingSGSN_number = -1;        /* OCTET_STRING_SIZE_1_20 */
static int hf_hi2_servingSGSN_address = -1;       /* OCTET_STRING_SIZE_5_17 */
static int hf_hi2_ldiEvent = -1;                  /* LDIevent */
static int hf_hi2_correlation = -1;               /* CorrelationValues */
static int hf_hi2_national_HI2_ASN1parameters = -1;  /* National_HI2_ASN1parameters */
static int hf_hi2_communication_Identity_Number = -1;  /* OCTET_STRING_SIZE_1_8 */
static int hf_hi2_network_Identifier = -1;        /* Network_Identifier */
static int hf_hi2_operator_Identifier = -1;       /* OCTET_STRING_SIZE_1_5 */
static int hf_hi2_network_Element_Identifier = -1;  /* Network_Element_Identifier */
static int hf_hi2_e164_Format = -1;               /* OCTET_STRING_SIZE_1_25 */
static int hf_hi2_x25_Format = -1;                /* OCTET_STRING_SIZE_1_25 */
static int hf_hi2_iP_Format = -1;                 /* OCTET_STRING_SIZE_1_25 */
static int hf_hi2_dNS_Format = -1;                /* OCTET_STRING_SIZE_1_25 */
static int hf_hi2_iP_Address = -1;                /* IPAddress */
static int hf_hi2_localTime = -1;                 /* LocalTimeStamp */
static int hf_hi2_utcTime = -1;                   /* UTCTime */
static int hf_hi2_generalizedTime = -1;           /* GeneralizedTime */
static int hf_hi2_winterSummerIndication = -1;    /* T_winterSummerIndication */
static int hf_hi2_party_Qualifier = -1;           /* T_party_Qualifier */
static int hf_hi2_partyIdentity = -1;             /* T_partyIdentity */
static int hf_hi2_imei = -1;                      /* OCTET_STRING_SIZE_8 */
static int hf_hi2_tei = -1;                       /* OCTET_STRING_SIZE_1_15 */
static int hf_hi2_imsi = -1;                      /* OCTET_STRING_SIZE_3_8 */
static int hf_hi2_callingPartyNumber = -1;        /* CallingPartyNumber */
static int hf_hi2_calledPartyNumber = -1;         /* CalledPartyNumber */
static int hf_hi2_msISDN = -1;                    /* OCTET_STRING_SIZE_1_9 */
static int hf_hi2_sip_uri = -1;                   /* OCTET_STRING */
static int hf_hi2_tel_url = -1;                   /* OCTET_STRING */
static int hf_hi2_services_Information = -1;      /* Services_Information */
static int hf_hi2_supplementary_Services_Information = -1;  /* Supplementary_Services */
static int hf_hi2_services_Data_Information = -1;  /* Services_Data_Information */
static int hf_hi2_iSUP_Format = -1;               /* OCTET_STRING_SIZE_1_25 */
static int hf_hi2_dSS1_Format = -1;               /* OCTET_STRING_SIZE_1_25 */
static int hf_hi2_mAP_Format = -1;                /* OCTET_STRING_SIZE_1_25 */
static int hf_hi2_e164_Number = -1;               /* OCTET_STRING_SIZE_1_25 */
static int hf_hi2_globalCellID = -1;              /* OCTET_STRING_SIZE_5_7 */
static int hf_hi2_tetraLocation = -1;             /* TetraLocation */
static int hf_hi2_rAI = -1;                       /* OCTET_STRING_SIZE_6 */
static int hf_hi2_gsmLocation = -1;               /* GSMLocation */
static int hf_hi2_umtsLocation = -1;              /* UMTSLocation */
static int hf_hi2_sAI = -1;                       /* OCTET_STRING_SIZE_7 */
static int hf_hi2_oldRAI = -1;                    /* OCTET_STRING_SIZE_6 */
static int hf_hi2_ms_Loc = -1;                    /* T_ms_Loc */
static int hf_hi2_mcc = -1;                       /* INTEGER_0_1023 */
static int hf_hi2_mnc = -1;                       /* INTEGER_0_16383 */
static int hf_hi2_lai = -1;                       /* INTEGER_0_65535 */
static int hf_hi2_ci = -1;                        /* INTEGER */
static int hf_hi2_ls_Loc = -1;                    /* INTEGER */
static int hf_hi2_geoCoordinates = -1;            /* T_geoCoordinates */
static int hf_hi2_latitude = -1;                  /* PrintableString_SIZE_7_10 */
static int hf_hi2_longitude = -1;                 /* PrintableString_SIZE_8_11 */
static int hf_hi2_mapDatum = -1;                  /* MapDatum */
static int hf_hi2_azimuth = -1;                   /* INTEGER_0_359 */
static int hf_hi2_utmCoordinates = -1;            /* T_utmCoordinates */
static int hf_hi2_utm_East = -1;                  /* PrintableString_SIZE_10 */
static int hf_hi2_utm_North = -1;                 /* PrintableString_SIZE_7 */
static int hf_hi2_utmRefCoordinates = -1;         /* T_utmRefCoordinates */
static int hf_hi2_utmref_string = -1;             /* PrintableString_SIZE_13 */
static int hf_hi2_wGS84Coordinates = -1;          /* OCTET_STRING */
static int hf_hi2_point = -1;                     /* GA_Point */
static int hf_hi2_pointWithUnCertainty = -1;      /* GA_PointWithUnCertainty */
static int hf_hi2_polygon = -1;                   /* GA_Polygon */
static int hf_hi2_latitudeSign = -1;              /* T_latitudeSign */
static int hf_hi2_latitude_01 = -1;               /* INTEGER_0_8388607 */
static int hf_hi2_longitude_01 = -1;              /* INTEGER_M8388608_8388607 */
static int hf_hi2_geographicalCoordinates = -1;   /* GeographicalCoordinates */
static int hf_hi2_uncertaintyCode = -1;           /* INTEGER_0_127 */
static int hf_hi2_GA_Polygon_item = -1;           /* GA_Polygon_item */
static int hf_hi2_cCLink_State = -1;              /* CCLink_State */
static int hf_hi2_release_Time = -1;              /* TimeStamp */
static int hf_hi2_release_Reason = -1;            /* OCTET_STRING_SIZE_2 */
static int hf_hi2_lEMF_Address = -1;              /* CalledPartyNumber */
static int hf_hi2_iSUP_parameters = -1;           /* ISUP_parameters */
static int hf_hi2_dSS1_parameters_codeset_0 = -1;  /* DSS1_parameters_codeset_0 */
static int hf_hi2_mAP_parameters = -1;            /* MAP_parameters */
static int hf_hi2_ISUP_parameters_item = -1;      /* OCTET_STRING_SIZE_1_256 */
static int hf_hi2_DSS1_parameters_codeset_0_item = -1;  /* OCTET_STRING_SIZE_1_256 */
static int hf_hi2_MAP_parameters_item = -1;       /* OCTET_STRING_SIZE_1_256 */
static int hf_hi2_standard_Supplementary_Services = -1;  /* Standard_Supplementary_Services */
static int hf_hi2_non_Standard_Supplementary_Services = -1;  /* Non_Standard_Supplementary_Services */
static int hf_hi2_other_Services = -1;            /* Other_Services */
static int hf_hi2_iSUP_SS_parameters = -1;        /* ISUP_SS_parameters */
static int hf_hi2_dSS1_SS_parameters_codeset_0 = -1;  /* DSS1_SS_parameters_codeset_0 */
static int hf_hi2_dSS1_SS_parameters_codeset_4 = -1;  /* DSS1_SS_parameters_codeset_4 */
static int hf_hi2_dSS1_SS_parameters_codeset_5 = -1;  /* DSS1_SS_parameters_codeset_5 */
static int hf_hi2_dSS1_SS_parameters_codeset_6 = -1;  /* DSS1_SS_parameters_codeset_6 */
static int hf_hi2_dSS1_SS_parameters_codeset_7 = -1;  /* DSS1_SS_parameters_codeset_7 */
static int hf_hi2_dSS1_SS_Invoke_components = -1;  /* DSS1_SS_Invoke_Components */
static int hf_hi2_mAP_SS_Parameters = -1;         /* MAP_SS_Parameters */
static int hf_hi2_mAP_SS_Invoke_Components = -1;  /* MAP_SS_Invoke_Components */
static int hf_hi2_Non_Standard_Supplementary_Services_item = -1;  /* Non_Standard_Supplementary_Services_item */
static int hf_hi2_simpleIndication = -1;          /* SimpleIndication */
static int hf_hi2_sciData = -1;                   /* SciDataMode */
static int hf_hi2_Other_Services_item = -1;       /* OCTET_STRING_SIZE_1_256 */
static int hf_hi2_ISUP_SS_parameters_item = -1;   /* OCTET_STRING_SIZE_1_256 */
static int hf_hi2_DSS1_SS_parameters_codeset_0_item = -1;  /* OCTET_STRING_SIZE_1_256 */
static int hf_hi2_DSS1_SS_parameters_codeset_4_item = -1;  /* OCTET_STRING_SIZE_1_256 */
static int hf_hi2_DSS1_SS_parameters_codeset_5_item = -1;  /* OCTET_STRING_SIZE_1_256 */
static int hf_hi2_DSS1_SS_parameters_codeset_6_item = -1;  /* OCTET_STRING_SIZE_1_256 */
static int hf_hi2_DSS1_SS_parameters_codeset_7_item = -1;  /* OCTET_STRING_SIZE_1_256 */
static int hf_hi2_DSS1_SS_Invoke_Components_item = -1;  /* OCTET_STRING_SIZE_1_256 */
static int hf_hi2_MAP_SS_Invoke_Components_item = -1;  /* OCTET_STRING_SIZE_1_256 */
static int hf_hi2_MAP_SS_Parameters_item = -1;    /* OCTET_STRING_SIZE_1_256 */
static int hf_hi2_sMS_Contents = -1;              /* T_sMS_Contents */
static int hf_hi2_initiator = -1;                 /* T_initiator */
static int hf_hi2_transfer_status = -1;           /* T_transfer_status */
static int hf_hi2_other_message = -1;             /* T_other_message */
static int hf_hi2_content = -1;                   /* OCTET_STRING_SIZE_1_270 */
static int hf_hi2_National_Parameters_item = -1;  /* OCTET_STRING_SIZE_1_256 */
static int hf_hi2_gPRS_parameters = -1;           /* GPRS_parameters */
static int hf_hi2_pDP_address_allocated_to_the_target = -1;  /* DataNodeAddress */
static int hf_hi2_aPN = -1;                       /* OCTET_STRING_SIZE_1_100 */
static int hf_hi2_pDP_type = -1;                  /* OCTET_STRING_SIZE_2 */
static int hf_hi2_ipAddress = -1;                 /* IPAddress */
static int hf_hi2_x25Address = -1;                /* X25Address */
static int hf_hi2_iP_type = -1;                   /* T_iP_type */
static int hf_hi2_iP_value = -1;                  /* IP_value */
static int hf_hi2_iP_assignment = -1;             /* T_iP_assignment */
static int hf_hi2_iPBinaryAddress = -1;           /* OCTET_STRING_SIZE_4_16 */
static int hf_hi2_iPTextAddress = -1;             /* IA5String_SIZE_7_45 */
static int hf_hi2_countryCode = -1;               /* PrintableString_SIZE_2 */
static int hf_hi2_qosMobileRadio = -1;            /* OCTET_STRING */
static int hf_hi2_qosGn = -1;                     /* OCTET_STRING */
static int hf_hi2_iri_to_CC = -1;                 /* IRI_to_CC_Correlation */
static int hf_hi2_iri_to_iri = -1;                /* IRI_to_IRI_Correlation */
static int hf_hi2_both_IRI_CC = -1;               /* T_both_IRI_CC */
static int hf_hi2_iri_CC = -1;                    /* IRI_to_CC_Correlation */
static int hf_hi2_iri_IRI = -1;                   /* IRI_to_IRI_Correlation */
static int hf_hi2_cc = -1;                        /* T_cc */
static int hf_hi2_cc_item = -1;                   /* OCTET_STRING */
static int hf_hi2_iri = -1;                       /* OCTET_STRING */

/*--- End of included file: packet-hi2-hf.c ---*/
#line 53 "packet-hi2-template.c"

/* Initialize the subtree pointers */

/*--- Included file: packet-hi2-ett.c ---*/
#line 1 "packet-hi2-ett.c"
static gint ett_hi2_IRIsContent = -1;
static gint ett_hi2_IRISequence = -1;
static gint ett_hi2_IRIContent = -1;
static gint ett_hi2_IRI_Parameters = -1;
static gint ett_hi2_SET_SIZE_1_10_OF_PartyInformation = -1;
static gint ett_hi2_T_callContentLinkInformation = -1;
static gint ett_hi2_CommunicationIdentifier = -1;
static gint ett_hi2_Network_Identifier = -1;
static gint ett_hi2_Network_Element_Identifier = -1;
static gint ett_hi2_TimeStamp = -1;
static gint ett_hi2_LocalTimeStamp = -1;
static gint ett_hi2_PartyInformation = -1;
static gint ett_hi2_T_partyIdentity = -1;
static gint ett_hi2_CallingPartyNumber = -1;
static gint ett_hi2_CalledPartyNumber = -1;
static gint ett_hi2_Location = -1;
static gint ett_hi2_TetraLocation = -1;
static gint ett_hi2_T_ms_Loc = -1;
static gint ett_hi2_GSMLocation = -1;
static gint ett_hi2_T_geoCoordinates = -1;
static gint ett_hi2_T_utmCoordinates = -1;
static gint ett_hi2_T_utmRefCoordinates = -1;
static gint ett_hi2_UMTSLocation = -1;
static gint ett_hi2_GeographicalCoordinates = -1;
static gint ett_hi2_GA_Point = -1;
static gint ett_hi2_GA_PointWithUnCertainty = -1;
static gint ett_hi2_GA_Polygon = -1;
static gint ett_hi2_GA_Polygon_item = -1;
static gint ett_hi2_CallContentLinkCharacteristics = -1;
static gint ett_hi2_Services_Information = -1;
static gint ett_hi2_ISUP_parameters = -1;
static gint ett_hi2_DSS1_parameters_codeset_0 = -1;
static gint ett_hi2_MAP_parameters = -1;
static gint ett_hi2_Supplementary_Services = -1;
static gint ett_hi2_Standard_Supplementary_Services = -1;
static gint ett_hi2_Non_Standard_Supplementary_Services = -1;
static gint ett_hi2_Non_Standard_Supplementary_Services_item = -1;
static gint ett_hi2_Other_Services = -1;
static gint ett_hi2_ISUP_SS_parameters = -1;
static gint ett_hi2_DSS1_SS_parameters_codeset_0 = -1;
static gint ett_hi2_DSS1_SS_parameters_codeset_4 = -1;
static gint ett_hi2_DSS1_SS_parameters_codeset_5 = -1;
static gint ett_hi2_DSS1_SS_parameters_codeset_6 = -1;
static gint ett_hi2_DSS1_SS_parameters_codeset_7 = -1;
static gint ett_hi2_DSS1_SS_Invoke_Components = -1;
static gint ett_hi2_MAP_SS_Invoke_Components = -1;
static gint ett_hi2_MAP_SS_Parameters = -1;
static gint ett_hi2_SMS_report = -1;
static gint ett_hi2_T_sMS_Contents = -1;
static gint ett_hi2_National_Parameters = -1;
static gint ett_hi2_Services_Data_Information = -1;
static gint ett_hi2_GPRS_parameters = -1;
static gint ett_hi2_DataNodeAddress = -1;
static gint ett_hi2_IPAddress = -1;
static gint ett_hi2_IP_value = -1;
static gint ett_hi2_National_HI2_ASN1parameters = -1;
static gint ett_hi2_UmtsQos = -1;
static gint ett_hi2_CorrelationValues = -1;
static gint ett_hi2_T_both_IRI_CC = -1;
static gint ett_hi2_IRI_to_CC_Correlation = -1;
static gint ett_hi2_T_cc = -1;

/*--- End of included file: packet-hi2-ett.c ---*/
#line 56 "packet-hi2-template.c"


/*--- Included file: packet-hi2-fn.c ---*/
#line 1 "packet-hi2-fn.c"


static int
dissect_hi2_OBJECT_IDENTIFIER(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_object_identifier(implicit_tag, actx, tree, tvb, offset, hf_index, NULL);

  return offset;
}


static const value_string hi2_T_iRIversion_vals[] = {
  {   2, "version2" },
  {   3, "version3" },
  {   4, "version4" },
  {   5, "version5" },
  {   6, "version6" },
  {   7, "version7" },
  {   8, "lastVersion" },
  { 0, NULL }
};


static int
dissect_hi2_T_iRIversion(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}



static int
dissect_hi2_LawfulInterceptionIdentifier(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_1_8(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_1_5(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_1_25(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const value_string hi2_T_iP_type_vals[] = {
  {   0, "iPV4" },
  {   1, "iPV6" },
  { 0, NULL }
};


static int
dissect_hi2_T_iP_type(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_4_16(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}



static int
dissect_hi2_IA5String_SIZE_7_45(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_restricted_string(implicit_tag, BER_UNI_TAG_IA5String,
                                            actx, tree, tvb, offset, hf_index,
                                            NULL);

  return offset;
}


static const value_string hi2_IP_value_vals[] = {
  {   1, "iPBinaryAddress" },
  {   2, "iPTextAddress" },
  { 0, NULL }
};

static const ber_choice_t IP_value_choice[] = {
  {   1, &hf_hi2_iPBinaryAddress , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_4_16 },
  {   2, &hf_hi2_iPTextAddress   , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_IA5String_SIZE_7_45 },
  { 0, NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_IP_value(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 IP_value_choice, hf_index, ett_hi2_IP_value,
                                 NULL);

  return offset;
}


static const value_string hi2_T_iP_assignment_vals[] = {
  {   1, "static" },
  {   2, "dynamic" },
  {   3, "notKnown" },
  { 0, NULL }
};


static int
dissect_hi2_T_iP_assignment(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}


static const ber_sequence_t IPAddress_sequence[] = {
  { &hf_hi2_iP_type         , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_T_iP_type },
  { &hf_hi2_iP_value        , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_IP_value },
  { &hf_hi2_iP_assignment   , BER_CLASS_CON, 3, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_T_iP_assignment },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_IPAddress(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   IPAddress_sequence, hf_index, ett_hi2_IPAddress);

  return offset;
}


static const value_string hi2_Network_Element_Identifier_vals[] = {
  {   1, "e164-Format" },
  {   2, "x25-Format" },
  {   3, "iP-Format" },
  {   4, "dNS-Format" },
  {   5, "iP-Address" },
  { 0, NULL }
};

static const ber_choice_t Network_Element_Identifier_choice[] = {
  {   1, &hf_hi2_e164_Format     , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_25 },
  {   2, &hf_hi2_x25_Format      , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_25 },
  {   3, &hf_hi2_iP_Format       , BER_CLASS_CON, 3, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_25 },
  {   4, &hf_hi2_dNS_Format      , BER_CLASS_CON, 4, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_25 },
  {   5, &hf_hi2_iP_Address      , BER_CLASS_CON, 5, BER_FLAGS_IMPLTAG, dissect_hi2_IPAddress },
  { 0, NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_Network_Element_Identifier(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 Network_Element_Identifier_choice, hf_index, ett_hi2_Network_Element_Identifier,
                                 NULL);

  return offset;
}


static const ber_sequence_t Network_Identifier_sequence[] = {
  { &hf_hi2_operator_Identifier, BER_CLASS_CON, 0, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_5 },
  { &hf_hi2_network_Element_Identifier, BER_CLASS_CON, 1, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_Network_Element_Identifier },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_Network_Identifier(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   Network_Identifier_sequence, hf_index, ett_hi2_Network_Identifier);

  return offset;
}


static const ber_sequence_t CommunicationIdentifier_sequence[] = {
  { &hf_hi2_communication_Identity_Number, BER_CLASS_CON, 0, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_8 },
  { &hf_hi2_network_Identifier, BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_Network_Identifier },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_CommunicationIdentifier(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   CommunicationIdentifier_sequence, hf_index, ett_hi2_CommunicationIdentifier);

  return offset;
}



static int
dissect_hi2_GeneralizedTime(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_GeneralizedTime(implicit_tag, actx, tree, tvb, offset, hf_index);

  return offset;
}


static const value_string hi2_T_winterSummerIndication_vals[] = {
  {   0, "notProvided" },
  {   1, "winterTime" },
  {   2, "summerTime" },
  { 0, NULL }
};


static int
dissect_hi2_T_winterSummerIndication(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}


static const ber_sequence_t LocalTimeStamp_sequence[] = {
  { &hf_hi2_generalizedTime , BER_CLASS_CON, 0, BER_FLAGS_IMPLTAG, dissect_hi2_GeneralizedTime },
  { &hf_hi2_winterSummerIndication, BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_T_winterSummerIndication },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_LocalTimeStamp(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   LocalTimeStamp_sequence, hf_index, ett_hi2_LocalTimeStamp);

  return offset;
}



static int
dissect_hi2_UTCTime(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_UTCTime(implicit_tag, actx, tree, tvb, offset, hf_index);

  return offset;
}


static const value_string hi2_TimeStamp_vals[] = {
  {   0, "localTime" },
  {   1, "utcTime" },
  { 0, NULL }
};

static const ber_choice_t TimeStamp_choice[] = {
  {   0, &hf_hi2_localTime       , BER_CLASS_CON, 0, BER_FLAGS_IMPLTAG, dissect_hi2_LocalTimeStamp },
  {   1, &hf_hi2_utcTime         , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_UTCTime },
  { 0, NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_TimeStamp(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 TimeStamp_choice, hf_index, ett_hi2_TimeStamp,
                                 NULL);

  return offset;
}


static const value_string hi2_T_intercepted_Call_Direct_vals[] = {
  {   0, "not-Available" },
  {   1, "originating-Target" },
  {   2, "terminating-Target" },
  { 0, NULL }
};


static int
dissect_hi2_T_intercepted_Call_Direct(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}


static const value_string hi2_Intercepted_Call_State_vals[] = {
  {   1, "idle" },
  {   2, "setUpInProcess" },
  {   3, "connected" },
  { 0, NULL }
};


static int
dissect_hi2_Intercepted_Call_State(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_3(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_5_7(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}



static int
dissect_hi2_INTEGER_0_1023(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                                NULL);

  return offset;
}



static int
dissect_hi2_INTEGER_0_16383(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                                NULL);

  return offset;
}



static int
dissect_hi2_INTEGER_0_65535(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                                NULL);

  return offset;
}



static int
dissect_hi2_INTEGER(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                                NULL);

  return offset;
}


static const ber_sequence_t T_ms_Loc_sequence[] = {
  { &hf_hi2_mcc             , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_INTEGER_0_1023 },
  { &hf_hi2_mnc             , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_INTEGER_0_16383 },
  { &hf_hi2_lai             , BER_CLASS_CON, 3, BER_FLAGS_IMPLTAG, dissect_hi2_INTEGER_0_65535 },
  { &hf_hi2_ci              , BER_CLASS_CON, 4, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_INTEGER },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_T_ms_Loc(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   T_ms_Loc_sequence, hf_index, ett_hi2_T_ms_Loc);

  return offset;
}


static const value_string hi2_TetraLocation_vals[] = {
  {   1, "ms-Loc" },
  {   2, "ls-Loc" },
  { 0, NULL }
};

static const ber_choice_t TetraLocation_choice[] = {
  {   1, &hf_hi2_ms_Loc          , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_T_ms_Loc },
  {   2, &hf_hi2_ls_Loc          , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_INTEGER },
  { 0, NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_TetraLocation(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 TetraLocation_choice, hf_index, ett_hi2_TetraLocation,
                                 NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_6(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}



static int
dissect_hi2_PrintableString_SIZE_7_10(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_restricted_string(implicit_tag, BER_UNI_TAG_PrintableString,
                                            actx, tree, tvb, offset, hf_index,
                                            NULL);

  return offset;
}



static int
dissect_hi2_PrintableString_SIZE_8_11(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_restricted_string(implicit_tag, BER_UNI_TAG_PrintableString,
                                            actx, tree, tvb, offset, hf_index,
                                            NULL);

  return offset;
}


static const value_string hi2_MapDatum_vals[] = {
  {   0, "wGS84" },
  {   1, "wGS72" },
  {   2, "eD50" },
  { 0, NULL }
};


static int
dissect_hi2_MapDatum(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}



static int
dissect_hi2_INTEGER_0_359(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                                NULL);

  return offset;
}


static const ber_sequence_t T_geoCoordinates_sequence[] = {
  { &hf_hi2_latitude        , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_PrintableString_SIZE_7_10 },
  { &hf_hi2_longitude       , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_PrintableString_SIZE_8_11 },
  { &hf_hi2_mapDatum        , BER_CLASS_CON, 3, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_MapDatum },
  { &hf_hi2_azimuth         , BER_CLASS_CON, 4, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_INTEGER_0_359 },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_T_geoCoordinates(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   T_geoCoordinates_sequence, hf_index, ett_hi2_T_geoCoordinates);

  return offset;
}



static int
dissect_hi2_PrintableString_SIZE_10(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_restricted_string(implicit_tag, BER_UNI_TAG_PrintableString,
                                            actx, tree, tvb, offset, hf_index,
                                            NULL);

  return offset;
}



static int
dissect_hi2_PrintableString_SIZE_7(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_restricted_string(implicit_tag, BER_UNI_TAG_PrintableString,
                                            actx, tree, tvb, offset, hf_index,
                                            NULL);

  return offset;
}


static const ber_sequence_t T_utmCoordinates_sequence[] = {
  { &hf_hi2_utm_East        , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_PrintableString_SIZE_10 },
  { &hf_hi2_utm_North       , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_PrintableString_SIZE_7 },
  { &hf_hi2_mapDatum        , BER_CLASS_CON, 3, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_MapDatum },
  { &hf_hi2_azimuth         , BER_CLASS_CON, 4, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_INTEGER_0_359 },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_T_utmCoordinates(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   T_utmCoordinates_sequence, hf_index, ett_hi2_T_utmCoordinates);

  return offset;
}



static int
dissect_hi2_PrintableString_SIZE_13(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_restricted_string(implicit_tag, BER_UNI_TAG_PrintableString,
                                            actx, tree, tvb, offset, hf_index,
                                            NULL);

  return offset;
}


static const ber_sequence_t T_utmRefCoordinates_sequence[] = {
  { &hf_hi2_utmref_string   , BER_CLASS_UNI, BER_UNI_TAG_PrintableString, BER_FLAGS_NOOWNTAG, dissect_hi2_PrintableString_SIZE_13 },
  { &hf_hi2_mapDatum        , BER_CLASS_UNI, BER_UNI_TAG_ENUMERATED, BER_FLAGS_OPTIONAL|BER_FLAGS_NOOWNTAG, dissect_hi2_MapDatum },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_T_utmRefCoordinates(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   T_utmRefCoordinates_sequence, hf_index, ett_hi2_T_utmRefCoordinates);

  return offset;
}



static int
dissect_hi2_OCTET_STRING(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const value_string hi2_GSMLocation_vals[] = {
  {   1, "geoCoordinates" },
  {   2, "utmCoordinates" },
  {   3, "utmRefCoordinates" },
  {   4, "wGS84Coordinates" },
  { 0, NULL }
};

static const ber_choice_t GSMLocation_choice[] = {
  {   1, &hf_hi2_geoCoordinates  , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_T_geoCoordinates },
  {   2, &hf_hi2_utmCoordinates  , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_T_utmCoordinates },
  {   3, &hf_hi2_utmRefCoordinates, BER_CLASS_CON, 3, BER_FLAGS_IMPLTAG, dissect_hi2_T_utmRefCoordinates },
  {   4, &hf_hi2_wGS84Coordinates, BER_CLASS_CON, 4, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING },
  { 0, NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_GSMLocation(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 GSMLocation_choice, hf_index, ett_hi2_GSMLocation,
                                 NULL);

  return offset;
}


static const value_string hi2_T_latitudeSign_vals[] = {
  {   0, "north" },
  {   1, "south" },
  { 0, NULL }
};


static int
dissect_hi2_T_latitudeSign(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}



static int
dissect_hi2_INTEGER_0_8388607(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                                NULL);

  return offset;
}



static int
dissect_hi2_INTEGER_M8388608_8388607(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                                NULL);

  return offset;
}


static const ber_sequence_t GeographicalCoordinates_sequence[] = {
  { &hf_hi2_latitudeSign    , BER_CLASS_UNI, BER_UNI_TAG_ENUMERATED, BER_FLAGS_NOOWNTAG, dissect_hi2_T_latitudeSign },
  { &hf_hi2_latitude_01     , BER_CLASS_UNI, BER_UNI_TAG_INTEGER, BER_FLAGS_NOOWNTAG, dissect_hi2_INTEGER_0_8388607 },
  { &hf_hi2_longitude_01    , BER_CLASS_UNI, BER_UNI_TAG_INTEGER, BER_FLAGS_NOOWNTAG, dissect_hi2_INTEGER_M8388608_8388607 },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_GeographicalCoordinates(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   GeographicalCoordinates_sequence, hf_index, ett_hi2_GeographicalCoordinates);

  return offset;
}


static const ber_sequence_t GA_Point_sequence[] = {
  { &hf_hi2_geographicalCoordinates, BER_CLASS_UNI, BER_UNI_TAG_SEQUENCE, BER_FLAGS_NOOWNTAG, dissect_hi2_GeographicalCoordinates },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_GA_Point(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   GA_Point_sequence, hf_index, ett_hi2_GA_Point);

  return offset;
}



static int
dissect_hi2_INTEGER_0_127(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                                NULL);

  return offset;
}


static const ber_sequence_t GA_PointWithUnCertainty_sequence[] = {
  { &hf_hi2_geographicalCoordinates, BER_CLASS_UNI, BER_UNI_TAG_SEQUENCE, BER_FLAGS_NOOWNTAG, dissect_hi2_GeographicalCoordinates },
  { &hf_hi2_uncertaintyCode , BER_CLASS_UNI, BER_UNI_TAG_INTEGER, BER_FLAGS_NOOWNTAG, dissect_hi2_INTEGER_0_127 },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_GA_PointWithUnCertainty(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   GA_PointWithUnCertainty_sequence, hf_index, ett_hi2_GA_PointWithUnCertainty);

  return offset;
}


static const ber_sequence_t GA_Polygon_item_sequence[] = {
  { &hf_hi2_geographicalCoordinates, BER_CLASS_UNI, BER_UNI_TAG_SEQUENCE, BER_FLAGS_NOOWNTAG, dissect_hi2_GeographicalCoordinates },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_GA_Polygon_item(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   GA_Polygon_item_sequence, hf_index, ett_hi2_GA_Polygon_item);

  return offset;
}


static const ber_sequence_t GA_Polygon_sequence_of[1] = {
  { &hf_hi2_GA_Polygon_item , BER_CLASS_UNI, BER_UNI_TAG_SEQUENCE, BER_FLAGS_NOOWNTAG, dissect_hi2_GA_Polygon_item },
};

static int
dissect_hi2_GA_Polygon(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence_of(implicit_tag, actx, tree, tvb, offset,
                                      GA_Polygon_sequence_of, hf_index, ett_hi2_GA_Polygon);

  return offset;
}


static const value_string hi2_UMTSLocation_vals[] = {
  {   1, "point" },
  {   2, "pointWithUnCertainty" },
  {   3, "polygon" },
  { 0, NULL }
};

static const ber_choice_t UMTSLocation_choice[] = {
  {   1, &hf_hi2_point           , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_GA_Point },
  {   2, &hf_hi2_pointWithUnCertainty, BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_GA_PointWithUnCertainty },
  {   3, &hf_hi2_polygon         , BER_CLASS_CON, 3, BER_FLAGS_IMPLTAG, dissect_hi2_GA_Polygon },
  { 0, NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_UMTSLocation(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 UMTSLocation_choice, hf_index, ett_hi2_UMTSLocation,
                                 NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_7(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const ber_sequence_t Location_sequence[] = {
  { &hf_hi2_e164_Number     , BER_CLASS_CON, 1, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_25 },
  { &hf_hi2_globalCellID    , BER_CLASS_CON, 2, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_5_7 },
  { &hf_hi2_tetraLocation   , BER_CLASS_CON, 3, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_TetraLocation },
  { &hf_hi2_rAI             , BER_CLASS_CON, 4, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_6 },
  { &hf_hi2_gsmLocation     , BER_CLASS_CON, 5, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_GSMLocation },
  { &hf_hi2_umtsLocation    , BER_CLASS_CON, 6, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_UMTSLocation },
  { &hf_hi2_sAI             , BER_CLASS_CON, 7, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_7 },
  { &hf_hi2_oldRAI          , BER_CLASS_CON, 8, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_6 },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_Location(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   Location_sequence, hf_index, ett_hi2_Location);

  return offset;
}


static const value_string hi2_T_party_Qualifier_vals[] = {
  {   0, "originating-Party" },
  {   1, "terminating-Party" },
  {   2, "forwarded-to-Party" },
  {   3, "gPRS-Target" },
  { 0, NULL }
};


static int
dissect_hi2_T_party_Qualifier(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_8(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_1_15(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_3_8(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const value_string hi2_CallingPartyNumber_vals[] = {
  {   1, "iSUP-Format" },
  {   2, "dSS1-Format" },
  {   3, "mAP-Format" },
  { 0, NULL }
};

static const ber_choice_t CallingPartyNumber_choice[] = {
  {   1, &hf_hi2_iSUP_Format     , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_25 },
  {   2, &hf_hi2_dSS1_Format     , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_25 },
  {   3, &hf_hi2_mAP_Format      , BER_CLASS_CON, 3, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_25 },
  { 0, NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_CallingPartyNumber(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 CallingPartyNumber_choice, hf_index, ett_hi2_CallingPartyNumber,
                                 NULL);

  return offset;
}


static const value_string hi2_CalledPartyNumber_vals[] = {
  {   1, "iSUP-Format" },
  {   2, "mAP-Format" },
  {   3, "dSS1-Format" },
  { 0, NULL }
};

static const ber_choice_t CalledPartyNumber_choice[] = {
  {   1, &hf_hi2_iSUP_Format     , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_25 },
  {   2, &hf_hi2_mAP_Format      , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_25 },
  {   3, &hf_hi2_dSS1_Format     , BER_CLASS_CON, 3, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_25 },
  { 0, NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_CalledPartyNumber(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 CalledPartyNumber_choice, hf_index, ett_hi2_CalledPartyNumber,
                                 NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_1_9(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const ber_sequence_t T_partyIdentity_sequence[] = {
  { &hf_hi2_imei            , BER_CLASS_CON, 1, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_8 },
  { &hf_hi2_tei             , BER_CLASS_CON, 2, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_15 },
  { &hf_hi2_imsi            , BER_CLASS_CON, 3, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_3_8 },
  { &hf_hi2_callingPartyNumber, BER_CLASS_CON, 4, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_CallingPartyNumber },
  { &hf_hi2_calledPartyNumber, BER_CLASS_CON, 5, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_CalledPartyNumber },
  { &hf_hi2_msISDN          , BER_CLASS_CON, 6, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_9 },
  { &hf_hi2_e164_Format     , BER_CLASS_CON, 7, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_25 },
  { &hf_hi2_sip_uri         , BER_CLASS_CON, 8, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING },
  { &hf_hi2_tel_url         , BER_CLASS_CON, 9, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_T_partyIdentity(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   T_partyIdentity_sequence, hf_index, ett_hi2_T_partyIdentity);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_1_256(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const ber_sequence_t ISUP_parameters_set_of[1] = {
  { &hf_hi2_ISUP_parameters_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_ISUP_parameters(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 ISUP_parameters_set_of, hf_index, ett_hi2_ISUP_parameters);

  return offset;
}


static const ber_sequence_t DSS1_parameters_codeset_0_set_of[1] = {
  { &hf_hi2_DSS1_parameters_codeset_0_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_DSS1_parameters_codeset_0(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 DSS1_parameters_codeset_0_set_of, hf_index, ett_hi2_DSS1_parameters_codeset_0);

  return offset;
}


static const ber_sequence_t MAP_parameters_set_of[1] = {
  { &hf_hi2_MAP_parameters_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_MAP_parameters(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 MAP_parameters_set_of, hf_index, ett_hi2_MAP_parameters);

  return offset;
}


static const ber_sequence_t Services_Information_sequence[] = {
  { &hf_hi2_iSUP_parameters , BER_CLASS_CON, 1, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_ISUP_parameters },
  { &hf_hi2_dSS1_parameters_codeset_0, BER_CLASS_CON, 2, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_DSS1_parameters_codeset_0 },
  { &hf_hi2_mAP_parameters  , BER_CLASS_CON, 3, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_MAP_parameters },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_Services_Information(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   Services_Information_sequence, hf_index, ett_hi2_Services_Information);

  return offset;
}


static const ber_sequence_t ISUP_SS_parameters_set_of[1] = {
  { &hf_hi2_ISUP_SS_parameters_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_ISUP_SS_parameters(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 ISUP_SS_parameters_set_of, hf_index, ett_hi2_ISUP_SS_parameters);

  return offset;
}


static const ber_sequence_t DSS1_SS_parameters_codeset_0_set_of[1] = {
  { &hf_hi2_DSS1_SS_parameters_codeset_0_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_DSS1_SS_parameters_codeset_0(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 DSS1_SS_parameters_codeset_0_set_of, hf_index, ett_hi2_DSS1_SS_parameters_codeset_0);

  return offset;
}


static const ber_sequence_t DSS1_SS_parameters_codeset_4_set_of[1] = {
  { &hf_hi2_DSS1_SS_parameters_codeset_4_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_DSS1_SS_parameters_codeset_4(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 DSS1_SS_parameters_codeset_4_set_of, hf_index, ett_hi2_DSS1_SS_parameters_codeset_4);

  return offset;
}


static const ber_sequence_t DSS1_SS_parameters_codeset_5_set_of[1] = {
  { &hf_hi2_DSS1_SS_parameters_codeset_5_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_DSS1_SS_parameters_codeset_5(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 DSS1_SS_parameters_codeset_5_set_of, hf_index, ett_hi2_DSS1_SS_parameters_codeset_5);

  return offset;
}


static const ber_sequence_t DSS1_SS_parameters_codeset_6_set_of[1] = {
  { &hf_hi2_DSS1_SS_parameters_codeset_6_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_DSS1_SS_parameters_codeset_6(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 DSS1_SS_parameters_codeset_6_set_of, hf_index, ett_hi2_DSS1_SS_parameters_codeset_6);

  return offset;
}


static const ber_sequence_t DSS1_SS_parameters_codeset_7_set_of[1] = {
  { &hf_hi2_DSS1_SS_parameters_codeset_7_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_DSS1_SS_parameters_codeset_7(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 DSS1_SS_parameters_codeset_7_set_of, hf_index, ett_hi2_DSS1_SS_parameters_codeset_7);

  return offset;
}


static const ber_sequence_t DSS1_SS_Invoke_Components_set_of[1] = {
  { &hf_hi2_DSS1_SS_Invoke_Components_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_DSS1_SS_Invoke_Components(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 DSS1_SS_Invoke_Components_set_of, hf_index, ett_hi2_DSS1_SS_Invoke_Components);

  return offset;
}


static const ber_sequence_t MAP_SS_Parameters_set_of[1] = {
  { &hf_hi2_MAP_SS_Parameters_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_MAP_SS_Parameters(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 MAP_SS_Parameters_set_of, hf_index, ett_hi2_MAP_SS_Parameters);

  return offset;
}


static const ber_sequence_t MAP_SS_Invoke_Components_set_of[1] = {
  { &hf_hi2_MAP_SS_Invoke_Components_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_MAP_SS_Invoke_Components(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 MAP_SS_Invoke_Components_set_of, hf_index, ett_hi2_MAP_SS_Invoke_Components);

  return offset;
}


static const ber_sequence_t Standard_Supplementary_Services_sequence[] = {
  { &hf_hi2_iSUP_SS_parameters, BER_CLASS_CON, 1, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_ISUP_SS_parameters },
  { &hf_hi2_dSS1_SS_parameters_codeset_0, BER_CLASS_CON, 2, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_DSS1_SS_parameters_codeset_0 },
  { &hf_hi2_dSS1_SS_parameters_codeset_4, BER_CLASS_CON, 3, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_DSS1_SS_parameters_codeset_4 },
  { &hf_hi2_dSS1_SS_parameters_codeset_5, BER_CLASS_CON, 4, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_DSS1_SS_parameters_codeset_5 },
  { &hf_hi2_dSS1_SS_parameters_codeset_6, BER_CLASS_CON, 5, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_DSS1_SS_parameters_codeset_6 },
  { &hf_hi2_dSS1_SS_parameters_codeset_7, BER_CLASS_CON, 6, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_DSS1_SS_parameters_codeset_7 },
  { &hf_hi2_dSS1_SS_Invoke_components, BER_CLASS_CON, 7, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_DSS1_SS_Invoke_Components },
  { &hf_hi2_mAP_SS_Parameters, BER_CLASS_CON, 8, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_MAP_SS_Parameters },
  { &hf_hi2_mAP_SS_Invoke_Components, BER_CLASS_CON, 9, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_MAP_SS_Invoke_Components },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_Standard_Supplementary_Services(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   Standard_Supplementary_Services_sequence, hf_index, ett_hi2_Standard_Supplementary_Services);

  return offset;
}


static const value_string hi2_SimpleIndication_vals[] = {
  {   0, "call-Waiting-Indication" },
  {   1, "add-conf-Indication" },
  {   2, "call-on-hold-Indication" },
  {   3, "retrieve-Indication" },
  {   4, "suspend-Indication" },
  {   5, "resume-Indication" },
  {   6, "answer-Indication" },
  { 0, NULL }
};


static int
dissect_hi2_SimpleIndication(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}



static int
dissect_hi2_SciDataMode(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const value_string hi2_Non_Standard_Supplementary_Services_item_vals[] = {
  {   1, "simpleIndication" },
  {   2, "sciData" },
  { 0, NULL }
};

static const ber_choice_t Non_Standard_Supplementary_Services_item_choice[] = {
  {   1, &hf_hi2_simpleIndication, BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_SimpleIndication },
  {   2, &hf_hi2_sciData         , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_SciDataMode },
  { 0, NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_Non_Standard_Supplementary_Services_item(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 Non_Standard_Supplementary_Services_item_choice, hf_index, ett_hi2_Non_Standard_Supplementary_Services_item,
                                 NULL);

  return offset;
}


static const ber_sequence_t Non_Standard_Supplementary_Services_set_of[1] = {
  { &hf_hi2_Non_Standard_Supplementary_Services_item, BER_CLASS_ANY/*choice*/, -1/*choice*/, BER_FLAGS_NOOWNTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_Non_Standard_Supplementary_Services_item },
};

static int
dissect_hi2_Non_Standard_Supplementary_Services(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 Non_Standard_Supplementary_Services_set_of, hf_index, ett_hi2_Non_Standard_Supplementary_Services);

  return offset;
}


static const ber_sequence_t Other_Services_set_of[1] = {
  { &hf_hi2_Other_Services_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_Other_Services(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 Other_Services_set_of, hf_index, ett_hi2_Other_Services);

  return offset;
}


static const ber_sequence_t Supplementary_Services_sequence[] = {
  { &hf_hi2_standard_Supplementary_Services, BER_CLASS_CON, 1, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_Standard_Supplementary_Services },
  { &hf_hi2_non_Standard_Supplementary_Services, BER_CLASS_CON, 2, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_Non_Standard_Supplementary_Services },
  { &hf_hi2_other_Services  , BER_CLASS_CON, 3, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_Other_Services },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_Supplementary_Services(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   Supplementary_Services_sequence, hf_index, ett_hi2_Supplementary_Services);

  return offset;
}



static int
dissect_hi2_X25Address(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const value_string hi2_DataNodeAddress_vals[] = {
  {   1, "ipAddress" },
  {   2, "x25Address" },
  { 0, NULL }
};

static const ber_choice_t DataNodeAddress_choice[] = {
  {   1, &hf_hi2_ipAddress       , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_IPAddress },
  {   2, &hf_hi2_x25Address      , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_X25Address },
  { 0, NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_DataNodeAddress(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 DataNodeAddress_choice, hf_index, ett_hi2_DataNodeAddress,
                                 NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_1_100(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_2(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const ber_sequence_t GPRS_parameters_sequence[] = {
  { &hf_hi2_pDP_address_allocated_to_the_target, BER_CLASS_CON, 1, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_DataNodeAddress },
  { &hf_hi2_aPN             , BER_CLASS_CON, 2, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_100 },
  { &hf_hi2_pDP_type        , BER_CLASS_CON, 3, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_2 },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_GPRS_parameters(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   GPRS_parameters_sequence, hf_index, ett_hi2_GPRS_parameters);

  return offset;
}


static const ber_sequence_t Services_Data_Information_sequence[] = {
  { &hf_hi2_gPRS_parameters , BER_CLASS_CON, 1, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_GPRS_parameters },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_Services_Data_Information(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   Services_Data_Information_sequence, hf_index, ett_hi2_Services_Data_Information);

  return offset;
}


static const ber_sequence_t PartyInformation_sequence[] = {
  { &hf_hi2_party_Qualifier , BER_CLASS_CON, 0, BER_FLAGS_IMPLTAG, dissect_hi2_T_party_Qualifier },
  { &hf_hi2_partyIdentity   , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_T_partyIdentity },
  { &hf_hi2_services_Information, BER_CLASS_CON, 2, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_Services_Information },
  { &hf_hi2_supplementary_Services_Information, BER_CLASS_CON, 3, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_Supplementary_Services },
  { &hf_hi2_services_Data_Information, BER_CLASS_CON, 4, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_Services_Data_Information },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_PartyInformation(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   PartyInformation_sequence, hf_index, ett_hi2_PartyInformation);

  return offset;
}


static const ber_sequence_t SET_SIZE_1_10_OF_PartyInformation_set_of[1] = {
  { &hf_hi2_partyInformation_item, BER_CLASS_UNI, BER_UNI_TAG_SEQUENCE, BER_FLAGS_NOOWNTAG, dissect_hi2_PartyInformation },
};

static int
dissect_hi2_SET_SIZE_1_10_OF_PartyInformation(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 SET_SIZE_1_10_OF_PartyInformation_set_of, hf_index, ett_hi2_SET_SIZE_1_10_OF_PartyInformation);

  return offset;
}


static const value_string hi2_CCLink_State_vals[] = {
  {   1, "setUpInProcess" },
  {   2, "callActive" },
  {   3, "callReleased" },
  {   4, "lack-of-resource" },
  { 0, NULL }
};


static int
dissect_hi2_CCLink_State(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}


static const ber_sequence_t CallContentLinkCharacteristics_sequence[] = {
  { &hf_hi2_cCLink_State    , BER_CLASS_CON, 1, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_CCLink_State },
  { &hf_hi2_release_Time    , BER_CLASS_CON, 2, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_TimeStamp },
  { &hf_hi2_release_Reason  , BER_CLASS_CON, 3, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_2 },
  { &hf_hi2_lEMF_Address    , BER_CLASS_CON, 4, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_CalledPartyNumber },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_CallContentLinkCharacteristics(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   CallContentLinkCharacteristics_sequence, hf_index, ett_hi2_CallContentLinkCharacteristics);

  return offset;
}


static const ber_sequence_t T_callContentLinkInformation_sequence[] = {
  { &hf_hi2_cCLink1Characteristics, BER_CLASS_CON, 1, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_CallContentLinkCharacteristics },
  { &hf_hi2_cCLink2Characteristics, BER_CLASS_CON, 2, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_CallContentLinkCharacteristics },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_T_callContentLinkInformation(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   T_callContentLinkInformation_sequence, hf_index, ett_hi2_T_callContentLinkInformation);

  return offset;
}


static const value_string hi2_T_nature_Of_The_intercepted_call_vals[] = {
  {   0, "gSM-ISDN-PSTN-circuit-call" },
  {   1, "gSM-SMS-Message" },
  {   2, "uUS4-Messages" },
  {   3, "tETRA-circuit-call" },
  {   4, "teTRA-Packet-Data" },
  {   5, "gPRS-Packet-Data" },
  {   6, "uMTS-circuit-call" },
  { 0, NULL }
};


static int
dissect_hi2_T_nature_Of_The_intercepted_call(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}


static const value_string hi2_T_initiator_vals[] = {
  {   0, "target" },
  {   1, "server" },
  {   2, "undefined-party" },
  { 0, NULL }
};


static int
dissect_hi2_T_initiator(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}


static const value_string hi2_T_transfer_status_vals[] = {
  {   0, "succeed-transfer" },
  {   1, "not-succeed-transfer" },
  {   2, "undefined" },
  { 0, NULL }
};


static int
dissect_hi2_T_transfer_status(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}


static const value_string hi2_T_other_message_vals[] = {
  {   0, "yes" },
  {   1, "no" },
  {   2, "undefined" },
  { 0, NULL }
};


static int
dissect_hi2_T_other_message(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_1_270(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const ber_sequence_t T_sMS_Contents_sequence[] = {
  { &hf_hi2_initiator       , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_T_initiator },
  { &hf_hi2_transfer_status , BER_CLASS_CON, 2, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_T_transfer_status },
  { &hf_hi2_other_message   , BER_CLASS_CON, 3, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_T_other_message },
  { &hf_hi2_content         , BER_CLASS_CON, 4, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_270 },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_T_sMS_Contents(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   T_sMS_Contents_sequence, hf_index, ett_hi2_T_sMS_Contents);

  return offset;
}


static const ber_sequence_t SMS_report_sequence[] = {
  { &hf_hi2_communicationIdentifier, BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_CommunicationIdentifier },
  { &hf_hi2_timeStamp       , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_TimeStamp },
  { &hf_hi2_sMS_Contents    , BER_CLASS_CON, 3, BER_FLAGS_IMPLTAG, dissect_hi2_T_sMS_Contents },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_SMS_report(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   SMS_report_sequence, hf_index, ett_hi2_SMS_report);

  return offset;
}



static int
dissect_hi2_CC_Link_Identifier(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const ber_sequence_t National_Parameters_set_of[1] = {
  { &hf_hi2_National_Parameters_item, BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING_SIZE_1_256 },
};

static int
dissect_hi2_National_Parameters(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 National_Parameters_set_of, hf_index, ett_hi2_National_Parameters);

  return offset;
}



static int
dissect_hi2_GPRSCorrelationNumber(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const value_string hi2_GPRSEvent_vals[] = {
  {   1, "pDPContextActivation" },
  {   2, "startOfInterceptionWithPDPContextActive" },
  {   4, "pDPContextDeactivation" },
  {   5, "gPRSAttach" },
  {   6, "gPRSDetach" },
  {  10, "cellOrRAUpdate" },
  {  11, "sMS" },
  {  13, "pDPContextModification" },
  { 0, NULL }
};


static int
dissect_hi2_GPRSEvent(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}



static int
dissect_hi2_GPRSOperationErrorCode(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const value_string hi2_UmtsQos_vals[] = {
  {   1, "qosMobileRadio" },
  {   2, "qosGn" },
  { 0, NULL }
};

static const ber_choice_t UmtsQos_choice[] = {
  {   1, &hf_hi2_qosMobileRadio  , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING },
  {   2, &hf_hi2_qosGn           , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING },
  { 0, NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_UmtsQos(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 UmtsQos_choice, hf_index, ett_hi2_UmtsQos,
                                 NULL);

  return offset;
}


static const value_string hi2_IMSevent_vals[] = {
  {   1, "unfilteredSIPmessage" },
  {   2, "sIPheaderOnly" },
  { 0, NULL }
};


static int
dissect_hi2_IMSevent(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_1_20(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}



static int
dissect_hi2_OCTET_STRING_SIZE_5_17(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const value_string hi2_LDIevent_vals[] = {
  {   1, "targetEntersIA" },
  {   2, "targetLeavesIA" },
  { 0, NULL }
};


static int
dissect_hi2_LDIevent(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_integer(implicit_tag, actx, tree, tvb, offset, hf_index,
                                  NULL);

  return offset;
}


static const ber_sequence_t T_cc_set_of[1] = {
  { &hf_hi2_cc_item         , BER_CLASS_UNI, BER_UNI_TAG_OCTETSTRING, BER_FLAGS_NOOWNTAG, dissect_hi2_OCTET_STRING },
};

static int
dissect_hi2_T_cc(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_set_of(implicit_tag, actx, tree, tvb, offset,
                                 T_cc_set_of, hf_index, ett_hi2_T_cc);

  return offset;
}


static const ber_sequence_t IRI_to_CC_Correlation_sequence[] = {
  { &hf_hi2_cc              , BER_CLASS_CON, 0, BER_FLAGS_IMPLTAG, dissect_hi2_T_cc },
  { &hf_hi2_iri             , BER_CLASS_CON, 1, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_IRI_to_CC_Correlation(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   IRI_to_CC_Correlation_sequence, hf_index, ett_hi2_IRI_to_CC_Correlation);

  return offset;
}



static int
dissect_hi2_IRI_to_IRI_Correlation(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_octet_string(implicit_tag, actx, tree, tvb, offset, hf_index,
                                       NULL);

  return offset;
}


static const ber_sequence_t T_both_IRI_CC_sequence[] = {
  { &hf_hi2_iri_CC          , BER_CLASS_CON, 0, BER_FLAGS_IMPLTAG, dissect_hi2_IRI_to_CC_Correlation },
  { &hf_hi2_iri_IRI         , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_IRI_to_IRI_Correlation },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_T_both_IRI_CC(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   T_both_IRI_CC_sequence, hf_index, ett_hi2_T_both_IRI_CC);

  return offset;
}


static const value_string hi2_CorrelationValues_vals[] = {
  {   0, "iri-to-CC" },
  {   1, "iri-to-iri" },
  {   2, "both-IRI-CC" },
  { 0, NULL }
};

static const ber_choice_t CorrelationValues_choice[] = {
  {   0, &hf_hi2_iri_to_CC       , BER_CLASS_CON, 0, BER_FLAGS_IMPLTAG, dissect_hi2_IRI_to_CC_Correlation },
  {   1, &hf_hi2_iri_to_iri      , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_IRI_to_IRI_Correlation },
  {   2, &hf_hi2_both_IRI_CC     , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_T_both_IRI_CC },
  { 0, NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_CorrelationValues(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 CorrelationValues_choice, hf_index, ett_hi2_CorrelationValues,
                                 NULL);

  return offset;
}



static int
dissect_hi2_PrintableString_SIZE_2(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_restricted_string(implicit_tag, BER_UNI_TAG_PrintableString,
                                            actx, tree, tvb, offset, hf_index,
                                            NULL);

  return offset;
}


static const ber_sequence_t National_HI2_ASN1parameters_sequence[] = {
  { &hf_hi2_countryCode     , BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_PrintableString_SIZE_2 },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_National_HI2_ASN1parameters(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   National_HI2_ASN1parameters_sequence, hf_index, ett_hi2_National_HI2_ASN1parameters);

  return offset;
}


static const ber_sequence_t IRI_Parameters_sequence[] = {
  { &hf_hi2_domainID        , BER_CLASS_CON, 0, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OBJECT_IDENTIFIER },
  { &hf_hi2_iRIversion      , BER_CLASS_CON, 23, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_T_iRIversion },
  { &hf_hi2_lawfulInterceptionIdentifier, BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_LawfulInterceptionIdentifier },
  { &hf_hi2_communicationIdentifier, BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_CommunicationIdentifier },
  { &hf_hi2_timeStamp       , BER_CLASS_CON, 3, BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_TimeStamp },
  { &hf_hi2_intercepted_Call_Direct, BER_CLASS_CON, 4, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_T_intercepted_Call_Direct },
  { &hf_hi2_intercepted_Call_State, BER_CLASS_CON, 5, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_Intercepted_Call_State },
  { &hf_hi2_ringingDuration , BER_CLASS_CON, 6, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_3 },
  { &hf_hi2_conversationDuration, BER_CLASS_CON, 7, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_3 },
  { &hf_hi2_locationOfTheTarget, BER_CLASS_CON, 8, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_Location },
  { &hf_hi2_partyInformation, BER_CLASS_CON, 9, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_SET_SIZE_1_10_OF_PartyInformation },
  { &hf_hi2_callContentLinkInformation, BER_CLASS_CON, 10, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_T_callContentLinkInformation },
  { &hf_hi2_release_Reason_Of_Intercepted_Call, BER_CLASS_CON, 11, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_2 },
  { &hf_hi2_nature_Of_The_intercepted_call, BER_CLASS_CON, 12, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_T_nature_Of_The_intercepted_call },
  { &hf_hi2_serverCenterAddress, BER_CLASS_CON, 13, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_PartyInformation },
  { &hf_hi2_sMS             , BER_CLASS_CON, 14, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_SMS_report },
  { &hf_hi2_cC_Link_Identifier, BER_CLASS_CON, 15, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_CC_Link_Identifier },
  { &hf_hi2_national_Parameters, BER_CLASS_CON, 16, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_National_Parameters },
  { &hf_hi2_gPRSCorrelationNumber, BER_CLASS_CON, 18, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_GPRSCorrelationNumber },
  { &hf_hi2_gPRSevent       , BER_CLASS_CON, 20, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_GPRSEvent },
  { &hf_hi2_sgsnAddress     , BER_CLASS_CON, 21, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_DataNodeAddress },
  { &hf_hi2_gPRSOperationErrorCode, BER_CLASS_CON, 22, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_GPRSOperationErrorCode },
  { &hf_hi2_ggsnAddress     , BER_CLASS_CON, 24, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_DataNodeAddress },
  { &hf_hi2_qOS             , BER_CLASS_CON, 25, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_UmtsQos },
  { &hf_hi2_networkIdentifier, BER_CLASS_CON, 26, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_Network_Identifier },
  { &hf_hi2_sMSOriginatingAddress, BER_CLASS_CON, 27, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_DataNodeAddress },
  { &hf_hi2_sMSTerminatingAddress, BER_CLASS_CON, 28, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_DataNodeAddress },
  { &hf_hi2_iMSevent        , BER_CLASS_CON, 29, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_IMSevent },
  { &hf_hi2_sIPMessage      , BER_CLASS_CON, 30, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING },
  { &hf_hi2_servingSGSN_number, BER_CLASS_CON, 31, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_1_20 },
  { &hf_hi2_servingSGSN_address, BER_CLASS_CON, 32, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_OCTET_STRING_SIZE_5_17 },
  { &hf_hi2_ldiEvent        , BER_CLASS_CON, 34, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_LDIevent },
  { &hf_hi2_correlation     , BER_CLASS_CON, 35, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_CorrelationValues },
  { &hf_hi2_national_HI2_ASN1parameters, BER_CLASS_CON, 255, BER_FLAGS_OPTIONAL|BER_FLAGS_IMPLTAG, dissect_hi2_National_HI2_ASN1parameters },
  { NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_IRI_Parameters(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence(implicit_tag, actx, tree, tvb, offset,
                                   IRI_Parameters_sequence, hf_index, ett_hi2_IRI_Parameters);

  return offset;
}


static const value_string hi2_IRIContent_vals[] = {
  {   1, "iRI-Begin-record" },
  {   2, "iRI-End-record" },
  {   3, "iRI-Continue-record" },
  {   4, "iRI-Report-record" },
  { 0, NULL }
};

static const ber_choice_t IRIContent_choice[] = {
  {   1, &hf_hi2_iRI_Begin_record, BER_CLASS_CON, 1, BER_FLAGS_IMPLTAG, dissect_hi2_IRI_Parameters },
  {   2, &hf_hi2_iRI_End_record  , BER_CLASS_CON, 2, BER_FLAGS_IMPLTAG, dissect_hi2_IRI_Parameters },
  {   3, &hf_hi2_iRI_Continue_record, BER_CLASS_CON, 3, BER_FLAGS_IMPLTAG, dissect_hi2_IRI_Parameters },
  {   4, &hf_hi2_iRI_Report_record, BER_CLASS_CON, 4, BER_FLAGS_IMPLTAG, dissect_hi2_IRI_Parameters },
  { 0, NULL, 0, 0, 0, NULL }
};

static int
dissect_hi2_IRIContent(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 IRIContent_choice, hf_index, ett_hi2_IRIContent,
                                 NULL);

  return offset;
}


static const ber_sequence_t IRISequence_sequence_of[1] = {
  { &hf_hi2_IRISequence_item, BER_CLASS_ANY/*choice*/, -1/*choice*/, BER_FLAGS_NOOWNTAG|BER_FLAGS_NOTCHKTAG, dissect_hi2_IRIContent },
};

static int
dissect_hi2_IRISequence(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_sequence_of(implicit_tag, actx, tree, tvb, offset,
                                      IRISequence_sequence_of, hf_index, ett_hi2_IRISequence);

  return offset;
}


const value_string hi2_IRIsContent_vals[] = {
  {   0, "iRIContent" },
  {   1, "iRISequence" },
  { 0, NULL }
};

static const ber_choice_t IRIsContent_choice[] = {
  {   0, &hf_hi2_iRIContent      , BER_CLASS_ANY/*choice*/, -1/*choice*/, BER_FLAGS_NOOWNTAG, dissect_hi2_IRIContent },
  {   1, &hf_hi2_iRISequence     , BER_CLASS_UNI, BER_UNI_TAG_SEQUENCE, BER_FLAGS_NOOWNTAG, dissect_hi2_IRISequence },
  { 0, NULL, 0, 0, 0, NULL }
};

int
dissect_hi2_IRIsContent(gboolean implicit_tag _U_, tvbuff_t *tvb _U_, int offset _U_, asn1_ctx_t *actx _U_, proto_tree *tree _U_, int hf_index _U_) {
  offset = dissect_ber_choice(actx, tree, tvb, offset,
                                 IRIsContent_choice, hf_index, ett_hi2_IRIsContent,
                                 NULL);

  return offset;
}

/*--- PDUs ---*/

static void dissect_IRIsContent_PDU(tvbuff_t *tvb _U_, packet_info *pinfo _U_, proto_tree *tree _U_) {
  asn1_ctx_t asn1_ctx;
  asn1_ctx_init(&asn1_ctx, ASN1_ENC_BER, TRUE, pinfo);
  dissect_hi2_IRIsContent(FALSE, tvb, 0, &asn1_ctx, tree, hf_hi2_IRIsContent_PDU);
}


/*--- End of included file: packet-hi2-fn.c ---*/
#line 58 "packet-hi2-template.c"


/*--- proto_register_hi2 ----------------------------------------------*/
void proto_register_hi2(void) {

  /* List of fields */
  static hf_register_info hf[] = {

/*--- Included file: packet-hi2-hfarr.c ---*/
#line 1 "packet-hi2-hfarr.c"
    { &hf_hi2_IRIsContent_PDU,
      { "IRIsContent", "hi2.IRIsContent",
        FT_UINT32, BASE_DEC, VALS(hi2_IRIsContent_vals), 0,
        "hi2.IRIsContent", HFILL }},
    { &hf_hi2_iRIContent,
      { "iRIContent", "hi2.iRIContent",
        FT_UINT32, BASE_DEC, VALS(hi2_IRIContent_vals), 0,
        "hi2.IRIContent", HFILL }},
    { &hf_hi2_iRISequence,
      { "iRISequence", "hi2.iRISequence",
        FT_UINT32, BASE_DEC, NULL, 0,
        "hi2.IRISequence", HFILL }},
    { &hf_hi2_IRISequence_item,
      { "IRISequence", "hi2.IRISequence_item",
        FT_UINT32, BASE_DEC, VALS(hi2_IRIContent_vals), 0,
        "hi2.IRIContent", HFILL }},
    { &hf_hi2_iRI_Begin_record,
      { "iRI-Begin-record", "hi2.iRI_Begin_record",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.IRI_Parameters", HFILL }},
    { &hf_hi2_iRI_End_record,
      { "iRI-End-record", "hi2.iRI_End_record",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.IRI_Parameters", HFILL }},
    { &hf_hi2_iRI_Continue_record,
      { "iRI-Continue-record", "hi2.iRI_Continue_record",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.IRI_Parameters", HFILL }},
    { &hf_hi2_iRI_Report_record,
      { "iRI-Report-record", "hi2.iRI_Report_record",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.IRI_Parameters", HFILL }},
    { &hf_hi2_domainID,
      { "domainID", "hi2.domainID",
        FT_OID, BASE_NONE, NULL, 0,
        "hi2.OBJECT_IDENTIFIER", HFILL }},
    { &hf_hi2_iRIversion,
      { "iRIversion", "hi2.iRIversion",
        FT_UINT32, BASE_DEC, VALS(hi2_T_iRIversion_vals), 0,
        "hi2.T_iRIversion", HFILL }},
    { &hf_hi2_lawfulInterceptionIdentifier,
      { "lawfulInterceptionIdentifier", "hi2.lawfulInterceptionIdentifier",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.LawfulInterceptionIdentifier", HFILL }},
    { &hf_hi2_communicationIdentifier,
      { "communicationIdentifier", "hi2.communicationIdentifier",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.CommunicationIdentifier", HFILL }},
    { &hf_hi2_timeStamp,
      { "timeStamp", "hi2.timeStamp",
        FT_UINT32, BASE_DEC, VALS(hi2_TimeStamp_vals), 0,
        "hi2.TimeStamp", HFILL }},
    { &hf_hi2_intercepted_Call_Direct,
      { "intercepted-Call-Direct", "hi2.intercepted_Call_Direct",
        FT_UINT32, BASE_DEC, VALS(hi2_T_intercepted_Call_Direct_vals), 0,
        "hi2.T_intercepted_Call_Direct", HFILL }},
    { &hf_hi2_intercepted_Call_State,
      { "intercepted-Call-State", "hi2.intercepted_Call_State",
        FT_UINT32, BASE_DEC, VALS(hi2_Intercepted_Call_State_vals), 0,
        "hi2.Intercepted_Call_State", HFILL }},
    { &hf_hi2_ringingDuration,
      { "ringingDuration", "hi2.ringingDuration",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_3", HFILL }},
    { &hf_hi2_conversationDuration,
      { "conversationDuration", "hi2.conversationDuration",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_3", HFILL }},
    { &hf_hi2_locationOfTheTarget,
      { "locationOfTheTarget", "hi2.locationOfTheTarget",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.Location", HFILL }},
    { &hf_hi2_partyInformation,
      { "partyInformation", "hi2.partyInformation",
        FT_UINT32, BASE_DEC, NULL, 0,
        "hi2.SET_SIZE_1_10_OF_PartyInformation", HFILL }},
    { &hf_hi2_partyInformation_item,
      { "partyInformation", "hi2.partyInformation_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.PartyInformation", HFILL }},
    { &hf_hi2_callContentLinkInformation,
      { "callContentLinkInformation", "hi2.callContentLinkInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.T_callContentLinkInformation", HFILL }},
    { &hf_hi2_cCLink1Characteristics,
      { "cCLink1Characteristics", "hi2.cCLink1Characteristics",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.CallContentLinkCharacteristics", HFILL }},
    { &hf_hi2_cCLink2Characteristics,
      { "cCLink2Characteristics", "hi2.cCLink2Characteristics",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.CallContentLinkCharacteristics", HFILL }},
    { &hf_hi2_release_Reason_Of_Intercepted_Call,
      { "release-Reason-Of-Intercepted-Call", "hi2.release_Reason_Of_Intercepted_Call",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_2", HFILL }},
    { &hf_hi2_nature_Of_The_intercepted_call,
      { "nature-Of-The-intercepted-call", "hi2.nature_Of_The_intercepted_call",
        FT_UINT32, BASE_DEC, VALS(hi2_T_nature_Of_The_intercepted_call_vals), 0,
        "hi2.T_nature_Of_The_intercepted_call", HFILL }},
    { &hf_hi2_serverCenterAddress,
      { "serverCenterAddress", "hi2.serverCenterAddress",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.PartyInformation", HFILL }},
    { &hf_hi2_sMS,
      { "sMS", "hi2.sMS",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.SMS_report", HFILL }},
    { &hf_hi2_cC_Link_Identifier,
      { "cC-Link-Identifier", "hi2.cC_Link_Identifier",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.CC_Link_Identifier", HFILL }},
    { &hf_hi2_national_Parameters,
      { "national-Parameters", "hi2.national_Parameters",
        FT_UINT32, BASE_DEC, NULL, 0,
        "hi2.National_Parameters", HFILL }},
    { &hf_hi2_gPRSCorrelationNumber,
      { "gPRSCorrelationNumber", "hi2.gPRSCorrelationNumber",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.GPRSCorrelationNumber", HFILL }},
    { &hf_hi2_gPRSevent,
      { "gPRSevent", "hi2.gPRSevent",
        FT_UINT32, BASE_DEC, VALS(hi2_GPRSEvent_vals), 0,
        "hi2.GPRSEvent", HFILL }},
    { &hf_hi2_sgsnAddress,
      { "sgsnAddress", "hi2.sgsnAddress",
        FT_UINT32, BASE_DEC, VALS(hi2_DataNodeAddress_vals), 0,
        "hi2.DataNodeAddress", HFILL }},
    { &hf_hi2_gPRSOperationErrorCode,
      { "gPRSOperationErrorCode", "hi2.gPRSOperationErrorCode",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.GPRSOperationErrorCode", HFILL }},
    { &hf_hi2_ggsnAddress,
      { "ggsnAddress", "hi2.ggsnAddress",
        FT_UINT32, BASE_DEC, VALS(hi2_DataNodeAddress_vals), 0,
        "hi2.DataNodeAddress", HFILL }},
    { &hf_hi2_qOS,
      { "qOS", "hi2.qOS",
        FT_UINT32, BASE_DEC, VALS(hi2_UmtsQos_vals), 0,
        "hi2.UmtsQos", HFILL }},
    { &hf_hi2_networkIdentifier,
      { "networkIdentifier", "hi2.networkIdentifier",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.Network_Identifier", HFILL }},
    { &hf_hi2_sMSOriginatingAddress,
      { "sMSOriginatingAddress", "hi2.sMSOriginatingAddress",
        FT_UINT32, BASE_DEC, VALS(hi2_DataNodeAddress_vals), 0,
        "hi2.DataNodeAddress", HFILL }},
    { &hf_hi2_sMSTerminatingAddress,
      { "sMSTerminatingAddress", "hi2.sMSTerminatingAddress",
        FT_UINT32, BASE_DEC, VALS(hi2_DataNodeAddress_vals), 0,
        "hi2.DataNodeAddress", HFILL }},
    { &hf_hi2_iMSevent,
      { "iMSevent", "hi2.iMSevent",
        FT_UINT32, BASE_DEC, VALS(hi2_IMSevent_vals), 0,
        "hi2.IMSevent", HFILL }},
    { &hf_hi2_sIPMessage,
      { "sIPMessage", "hi2.sIPMessage",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING", HFILL }},
    { &hf_hi2_servingSGSN_number,
      { "servingSGSN-number", "hi2.servingSGSN_number",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_20", HFILL }},
    { &hf_hi2_servingSGSN_address,
      { "servingSGSN-address", "hi2.servingSGSN_address",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_5_17", HFILL }},
    { &hf_hi2_ldiEvent,
      { "ldiEvent", "hi2.ldiEvent",
        FT_UINT32, BASE_DEC, VALS(hi2_LDIevent_vals), 0,
        "hi2.LDIevent", HFILL }},
    { &hf_hi2_correlation,
      { "correlation", "hi2.correlation",
        FT_UINT32, BASE_DEC, VALS(hi2_CorrelationValues_vals), 0,
        "hi2.CorrelationValues", HFILL }},
    { &hf_hi2_national_HI2_ASN1parameters,
      { "national-HI2-ASN1parameters", "hi2.national_HI2_ASN1parameters",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.National_HI2_ASN1parameters", HFILL }},
    { &hf_hi2_communication_Identity_Number,
      { "communication-Identity-Number", "hi2.communication_Identity_Number",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_8", HFILL }},
    { &hf_hi2_network_Identifier,
      { "network-Identifier", "hi2.network_Identifier",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.Network_Identifier", HFILL }},
    { &hf_hi2_operator_Identifier,
      { "operator-Identifier", "hi2.operator_Identifier",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_5", HFILL }},
    { &hf_hi2_network_Element_Identifier,
      { "network-Element-Identifier", "hi2.network_Element_Identifier",
        FT_UINT32, BASE_DEC, VALS(hi2_Network_Element_Identifier_vals), 0,
        "hi2.Network_Element_Identifier", HFILL }},
    { &hf_hi2_e164_Format,
      { "e164-Format", "hi2.e164_Format",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_25", HFILL }},
    { &hf_hi2_x25_Format,
      { "x25-Format", "hi2.x25_Format",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_25", HFILL }},
    { &hf_hi2_iP_Format,
      { "iP-Format", "hi2.iP_Format",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_25", HFILL }},
    { &hf_hi2_dNS_Format,
      { "dNS-Format", "hi2.dNS_Format",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_25", HFILL }},
    { &hf_hi2_iP_Address,
      { "iP-Address", "hi2.iP_Address",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.IPAddress", HFILL }},
    { &hf_hi2_localTime,
      { "localTime", "hi2.localTime",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.LocalTimeStamp", HFILL }},
    { &hf_hi2_utcTime,
      { "utcTime", "hi2.utcTime",
        FT_STRING, BASE_NONE, NULL, 0,
        "hi2.UTCTime", HFILL }},
    { &hf_hi2_generalizedTime,
      { "generalizedTime", "hi2.generalizedTime",
        FT_STRING, BASE_NONE, NULL, 0,
        "hi2.GeneralizedTime", HFILL }},
    { &hf_hi2_winterSummerIndication,
      { "winterSummerIndication", "hi2.winterSummerIndication",
        FT_UINT32, BASE_DEC, VALS(hi2_T_winterSummerIndication_vals), 0,
        "hi2.T_winterSummerIndication", HFILL }},
    { &hf_hi2_party_Qualifier,
      { "party-Qualifier", "hi2.party_Qualifier",
        FT_UINT32, BASE_DEC, VALS(hi2_T_party_Qualifier_vals), 0,
        "hi2.T_party_Qualifier", HFILL }},
    { &hf_hi2_partyIdentity,
      { "partyIdentity", "hi2.partyIdentity",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.T_partyIdentity", HFILL }},
    { &hf_hi2_imei,
      { "imei", "hi2.imei",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_8", HFILL }},
    { &hf_hi2_tei,
      { "tei", "hi2.tei",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_15", HFILL }},
    { &hf_hi2_imsi,
      { "imsi", "hi2.imsi",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_3_8", HFILL }},
    { &hf_hi2_callingPartyNumber,
      { "callingPartyNumber", "hi2.callingPartyNumber",
        FT_UINT32, BASE_DEC, VALS(hi2_CallingPartyNumber_vals), 0,
        "hi2.CallingPartyNumber", HFILL }},
    { &hf_hi2_calledPartyNumber,
      { "calledPartyNumber", "hi2.calledPartyNumber",
        FT_UINT32, BASE_DEC, VALS(hi2_CalledPartyNumber_vals), 0,
        "hi2.CalledPartyNumber", HFILL }},
    { &hf_hi2_msISDN,
      { "msISDN", "hi2.msISDN",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_9", HFILL }},
    { &hf_hi2_sip_uri,
      { "sip-uri", "hi2.sip_uri",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING", HFILL }},
    { &hf_hi2_tel_url,
      { "tel-url", "hi2.tel_url",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING", HFILL }},
    { &hf_hi2_services_Information,
      { "services-Information", "hi2.services_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.Services_Information", HFILL }},
    { &hf_hi2_supplementary_Services_Information,
      { "supplementary-Services-Information", "hi2.supplementary_Services_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.Supplementary_Services", HFILL }},
    { &hf_hi2_services_Data_Information,
      { "services-Data-Information", "hi2.services_Data_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.Services_Data_Information", HFILL }},
    { &hf_hi2_iSUP_Format,
      { "iSUP-Format", "hi2.iSUP_Format",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_25", HFILL }},
    { &hf_hi2_dSS1_Format,
      { "dSS1-Format", "hi2.dSS1_Format",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_25", HFILL }},
    { &hf_hi2_mAP_Format,
      { "mAP-Format", "hi2.mAP_Format",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_25", HFILL }},
    { &hf_hi2_e164_Number,
      { "e164-Number", "hi2.e164_Number",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_25", HFILL }},
    { &hf_hi2_globalCellID,
      { "globalCellID", "hi2.globalCellID",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_5_7", HFILL }},
    { &hf_hi2_tetraLocation,
      { "tetraLocation", "hi2.tetraLocation",
        FT_UINT32, BASE_DEC, VALS(hi2_TetraLocation_vals), 0,
        "hi2.TetraLocation", HFILL }},
    { &hf_hi2_rAI,
      { "rAI", "hi2.rAI",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_6", HFILL }},
    { &hf_hi2_gsmLocation,
      { "gsmLocation", "hi2.gsmLocation",
        FT_UINT32, BASE_DEC, VALS(hi2_GSMLocation_vals), 0,
        "hi2.GSMLocation", HFILL }},
    { &hf_hi2_umtsLocation,
      { "umtsLocation", "hi2.umtsLocation",
        FT_UINT32, BASE_DEC, VALS(hi2_UMTSLocation_vals), 0,
        "hi2.UMTSLocation", HFILL }},
    { &hf_hi2_sAI,
      { "sAI", "hi2.sAI",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_7", HFILL }},
    { &hf_hi2_oldRAI,
      { "oldRAI", "hi2.oldRAI",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_6", HFILL }},
    { &hf_hi2_ms_Loc,
      { "ms-Loc", "hi2.ms_Loc",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.T_ms_Loc", HFILL }},
    { &hf_hi2_mcc,
      { "mcc", "hi2.mcc",
        FT_UINT32, BASE_DEC, NULL, 0,
        "hi2.INTEGER_0_1023", HFILL }},
    { &hf_hi2_mnc,
      { "mnc", "hi2.mnc",
        FT_UINT32, BASE_DEC, NULL, 0,
        "hi2.INTEGER_0_16383", HFILL }},
    { &hf_hi2_lai,
      { "lai", "hi2.lai",
        FT_UINT32, BASE_DEC, NULL, 0,
        "hi2.INTEGER_0_65535", HFILL }},
    { &hf_hi2_ci,
      { "ci", "hi2.ci",
        FT_INT32, BASE_DEC, NULL, 0,
        "hi2.INTEGER", HFILL }},
    { &hf_hi2_ls_Loc,
      { "ls-Loc", "hi2.ls_Loc",
        FT_INT32, BASE_DEC, NULL, 0,
        "hi2.INTEGER", HFILL }},
    { &hf_hi2_geoCoordinates,
      { "geoCoordinates", "hi2.geoCoordinates",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.T_geoCoordinates", HFILL }},
    { &hf_hi2_latitude,
      { "latitude", "hi2.latitude",
        FT_STRING, BASE_NONE, NULL, 0,
        "hi2.PrintableString_SIZE_7_10", HFILL }},
    { &hf_hi2_longitude,
      { "longitude", "hi2.longitude",
        FT_STRING, BASE_NONE, NULL, 0,
        "hi2.PrintableString_SIZE_8_11", HFILL }},
    { &hf_hi2_mapDatum,
      { "mapDatum", "hi2.mapDatum",
        FT_UINT32, BASE_DEC, VALS(hi2_MapDatum_vals), 0,
        "hi2.MapDatum", HFILL }},
    { &hf_hi2_azimuth,
      { "azimuth", "hi2.azimuth",
        FT_UINT32, BASE_DEC, NULL, 0,
        "hi2.INTEGER_0_359", HFILL }},
    { &hf_hi2_utmCoordinates,
      { "utmCoordinates", "hi2.utmCoordinates",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.T_utmCoordinates", HFILL }},
    { &hf_hi2_utm_East,
      { "utm-East", "hi2.utm_East",
        FT_STRING, BASE_NONE, NULL, 0,
        "hi2.PrintableString_SIZE_10", HFILL }},
    { &hf_hi2_utm_North,
      { "utm-North", "hi2.utm_North",
        FT_STRING, BASE_NONE, NULL, 0,
        "hi2.PrintableString_SIZE_7", HFILL }},
    { &hf_hi2_utmRefCoordinates,
      { "utmRefCoordinates", "hi2.utmRefCoordinates",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.T_utmRefCoordinates", HFILL }},
    { &hf_hi2_utmref_string,
      { "utmref-string", "hi2.utmref_string",
        FT_STRING, BASE_NONE, NULL, 0,
        "hi2.PrintableString_SIZE_13", HFILL }},
    { &hf_hi2_wGS84Coordinates,
      { "wGS84Coordinates", "hi2.wGS84Coordinates",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING", HFILL }},
    { &hf_hi2_point,
      { "point", "hi2.point",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.GA_Point", HFILL }},
    { &hf_hi2_pointWithUnCertainty,
      { "pointWithUnCertainty", "hi2.pointWithUnCertainty",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.GA_PointWithUnCertainty", HFILL }},
    { &hf_hi2_polygon,
      { "polygon", "hi2.polygon",
        FT_UINT32, BASE_DEC, NULL, 0,
        "hi2.GA_Polygon", HFILL }},
    { &hf_hi2_latitudeSign,
      { "latitudeSign", "hi2.latitudeSign",
        FT_UINT32, BASE_DEC, VALS(hi2_T_latitudeSign_vals), 0,
        "hi2.T_latitudeSign", HFILL }},
    { &hf_hi2_latitude_01,
      { "latitude", "hi2.latitude",
        FT_UINT32, BASE_DEC, NULL, 0,
        "hi2.INTEGER_0_8388607", HFILL }},
    { &hf_hi2_longitude_01,
      { "longitude", "hi2.longitude",
        FT_INT32, BASE_DEC, NULL, 0,
        "hi2.INTEGER_M8388608_8388607", HFILL }},
    { &hf_hi2_geographicalCoordinates,
      { "geographicalCoordinates", "hi2.geographicalCoordinates",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.GeographicalCoordinates", HFILL }},
    { &hf_hi2_uncertaintyCode,
      { "uncertaintyCode", "hi2.uncertaintyCode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "hi2.INTEGER_0_127", HFILL }},
    { &hf_hi2_GA_Polygon_item,
      { "GA-Polygon", "hi2.GA_Polygon_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.GA_Polygon_item", HFILL }},
    { &hf_hi2_cCLink_State,
      { "cCLink-State", "hi2.cCLink_State",
        FT_UINT32, BASE_DEC, VALS(hi2_CCLink_State_vals), 0,
        "hi2.CCLink_State", HFILL }},
    { &hf_hi2_release_Time,
      { "release-Time", "hi2.release_Time",
        FT_UINT32, BASE_DEC, VALS(hi2_TimeStamp_vals), 0,
        "hi2.TimeStamp", HFILL }},
    { &hf_hi2_release_Reason,
      { "release-Reason", "hi2.release_Reason",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_2", HFILL }},
    { &hf_hi2_lEMF_Address,
      { "lEMF-Address", "hi2.lEMF_Address",
        FT_UINT32, BASE_DEC, VALS(hi2_CalledPartyNumber_vals), 0,
        "hi2.CalledPartyNumber", HFILL }},
    { &hf_hi2_iSUP_parameters,
      { "iSUP-parameters", "hi2.iSUP_parameters",
        FT_UINT32, BASE_DEC, NULL, 0,
        "hi2.ISUP_parameters", HFILL }},
    { &hf_hi2_dSS1_parameters_codeset_0,
      { "dSS1-parameters-codeset-0", "hi2.dSS1_parameters_codeset_0",
        FT_UINT32, BASE_DEC, NULL, 0,
        "hi2.DSS1_parameters_codeset_0", HFILL }},
    { &hf_hi2_mAP_parameters,
      { "mAP-parameters", "hi2.mAP_parameters",
        FT_UINT32, BASE_DEC, NULL, 0,
        "hi2.MAP_parameters", HFILL }},
    { &hf_hi2_ISUP_parameters_item,
      { "ISUP-parameters", "hi2.ISUP_parameters_item",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_256", HFILL }},
    { &hf_hi2_DSS1_parameters_codeset_0_item,
      { "DSS1-parameters-codeset-0", "hi2.DSS1_parameters_codeset_0_item",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_256", HFILL }},
    { &hf_hi2_MAP_parameters_item,
      { "MAP-parameters", "hi2.MAP_parameters_item",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_256", HFILL }},
    { &hf_hi2_standard_Supplementary_Services,
      { "standard-Supplementary-Services", "hi2.standard_Supplementary_Services",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.Standard_Supplementary_Services", HFILL }},
    { &hf_hi2_non_Standard_Supplementary_Services,
      { "non-Standard-Supplementary-Services", "hi2.non_Standard_Supplementary_Services",
        FT_UINT32, BASE_DEC, NULL, 0,
        "hi2.Non_Standard_Supplementary_Services", HFILL }},
    { &hf_hi2_other_Services,
      { "other-Services", "hi2.other_Services",
        FT_UINT32, BASE_DEC, NULL, 0,
        "hi2.Other_Services", HFILL }},
    { &hf_hi2_iSUP_SS_parameters,
      { "iSUP-SS-parameters", "hi2.iSUP_SS_parameters",
        FT_UINT32, BASE_DEC, NULL, 0,
        "hi2.ISUP_SS_parameters", HFILL }},
    { &hf_hi2_dSS1_SS_parameters_codeset_0,
      { "dSS1-SS-parameters-codeset-0", "hi2.dSS1_SS_parameters_codeset_0",
        FT_UINT32, BASE_DEC, NULL, 0,
        "hi2.DSS1_SS_parameters_codeset_0", HFILL }},
    { &hf_hi2_dSS1_SS_parameters_codeset_4,
      { "dSS1-SS-parameters-codeset-4", "hi2.dSS1_SS_parameters_codeset_4",
        FT_UINT32, BASE_DEC, NULL, 0,
        "hi2.DSS1_SS_parameters_codeset_4", HFILL }},
    { &hf_hi2_dSS1_SS_parameters_codeset_5,
      { "dSS1-SS-parameters-codeset-5", "hi2.dSS1_SS_parameters_codeset_5",
        FT_UINT32, BASE_DEC, NULL, 0,
        "hi2.DSS1_SS_parameters_codeset_5", HFILL }},
    { &hf_hi2_dSS1_SS_parameters_codeset_6,
      { "dSS1-SS-parameters-codeset-6", "hi2.dSS1_SS_parameters_codeset_6",
        FT_UINT32, BASE_DEC, NULL, 0,
        "hi2.DSS1_SS_parameters_codeset_6", HFILL }},
    { &hf_hi2_dSS1_SS_parameters_codeset_7,
      { "dSS1-SS-parameters-codeset-7", "hi2.dSS1_SS_parameters_codeset_7",
        FT_UINT32, BASE_DEC, NULL, 0,
        "hi2.DSS1_SS_parameters_codeset_7", HFILL }},
    { &hf_hi2_dSS1_SS_Invoke_components,
      { "dSS1-SS-Invoke-components", "hi2.dSS1_SS_Invoke_components",
        FT_UINT32, BASE_DEC, NULL, 0,
        "hi2.DSS1_SS_Invoke_Components", HFILL }},
    { &hf_hi2_mAP_SS_Parameters,
      { "mAP-SS-Parameters", "hi2.mAP_SS_Parameters",
        FT_UINT32, BASE_DEC, NULL, 0,
        "hi2.MAP_SS_Parameters", HFILL }},
    { &hf_hi2_mAP_SS_Invoke_Components,
      { "mAP-SS-Invoke-Components", "hi2.mAP_SS_Invoke_Components",
        FT_UINT32, BASE_DEC, NULL, 0,
        "hi2.MAP_SS_Invoke_Components", HFILL }},
    { &hf_hi2_Non_Standard_Supplementary_Services_item,
      { "Non-Standard-Supplementary-Services", "hi2.Non_Standard_Supplementary_Services_item",
        FT_UINT32, BASE_DEC, VALS(hi2_Non_Standard_Supplementary_Services_item_vals), 0,
        "hi2.Non_Standard_Supplementary_Services_item", HFILL }},
    { &hf_hi2_simpleIndication,
      { "simpleIndication", "hi2.simpleIndication",
        FT_UINT32, BASE_DEC, VALS(hi2_SimpleIndication_vals), 0,
        "hi2.SimpleIndication", HFILL }},
    { &hf_hi2_sciData,
      { "sciData", "hi2.sciData",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.SciDataMode", HFILL }},
    { &hf_hi2_Other_Services_item,
      { "Other-Services", "hi2.Other_Services_item",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_256", HFILL }},
    { &hf_hi2_ISUP_SS_parameters_item,
      { "ISUP-SS-parameters", "hi2.ISUP_SS_parameters_item",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_256", HFILL }},
    { &hf_hi2_DSS1_SS_parameters_codeset_0_item,
      { "DSS1-SS-parameters-codeset-0", "hi2.DSS1_SS_parameters_codeset_0_item",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_256", HFILL }},
    { &hf_hi2_DSS1_SS_parameters_codeset_4_item,
      { "DSS1-SS-parameters-codeset-4", "hi2.DSS1_SS_parameters_codeset_4_item",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_256", HFILL }},
    { &hf_hi2_DSS1_SS_parameters_codeset_5_item,
      { "DSS1-SS-parameters-codeset-5", "hi2.DSS1_SS_parameters_codeset_5_item",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_256", HFILL }},
    { &hf_hi2_DSS1_SS_parameters_codeset_6_item,
      { "DSS1-SS-parameters-codeset-6", "hi2.DSS1_SS_parameters_codeset_6_item",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_256", HFILL }},
    { &hf_hi2_DSS1_SS_parameters_codeset_7_item,
      { "DSS1-SS-parameters-codeset-7", "hi2.DSS1_SS_parameters_codeset_7_item",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_256", HFILL }},
    { &hf_hi2_DSS1_SS_Invoke_Components_item,
      { "DSS1-SS-Invoke-Components", "hi2.DSS1_SS_Invoke_Components_item",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_256", HFILL }},
    { &hf_hi2_MAP_SS_Invoke_Components_item,
      { "MAP-SS-Invoke-Components", "hi2.MAP_SS_Invoke_Components_item",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_256", HFILL }},
    { &hf_hi2_MAP_SS_Parameters_item,
      { "MAP-SS-Parameters", "hi2.MAP_SS_Parameters_item",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_256", HFILL }},
    { &hf_hi2_sMS_Contents,
      { "sMS-Contents", "hi2.sMS_Contents",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.T_sMS_Contents", HFILL }},
    { &hf_hi2_initiator,
      { "initiator", "hi2.initiator",
        FT_UINT32, BASE_DEC, VALS(hi2_T_initiator_vals), 0,
        "hi2.T_initiator", HFILL }},
    { &hf_hi2_transfer_status,
      { "transfer-status", "hi2.transfer_status",
        FT_UINT32, BASE_DEC, VALS(hi2_T_transfer_status_vals), 0,
        "hi2.T_transfer_status", HFILL }},
    { &hf_hi2_other_message,
      { "other-message", "hi2.other_message",
        FT_UINT32, BASE_DEC, VALS(hi2_T_other_message_vals), 0,
        "hi2.T_other_message", HFILL }},
    { &hf_hi2_content,
      { "content", "hi2.content",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_270", HFILL }},
    { &hf_hi2_National_Parameters_item,
      { "National-Parameters", "hi2.National_Parameters_item",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_256", HFILL }},
    { &hf_hi2_gPRS_parameters,
      { "gPRS-parameters", "hi2.gPRS_parameters",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.GPRS_parameters", HFILL }},
    { &hf_hi2_pDP_address_allocated_to_the_target,
      { "pDP-address-allocated-to-the-target", "hi2.pDP_address_allocated_to_the_target",
        FT_UINT32, BASE_DEC, VALS(hi2_DataNodeAddress_vals), 0,
        "hi2.DataNodeAddress", HFILL }},
    { &hf_hi2_aPN,
      { "aPN", "hi2.aPN",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_1_100", HFILL }},
    { &hf_hi2_pDP_type,
      { "pDP-type", "hi2.pDP_type",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_2", HFILL }},
    { &hf_hi2_ipAddress,
      { "ipAddress", "hi2.ipAddress",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.IPAddress", HFILL }},
    { &hf_hi2_x25Address,
      { "x25Address", "hi2.x25Address",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.X25Address", HFILL }},
    { &hf_hi2_iP_type,
      { "iP-type", "hi2.iP_type",
        FT_UINT32, BASE_DEC, VALS(hi2_T_iP_type_vals), 0,
        "hi2.T_iP_type", HFILL }},
    { &hf_hi2_iP_value,
      { "iP-value", "hi2.iP_value",
        FT_UINT32, BASE_DEC, VALS(hi2_IP_value_vals), 0,
        "hi2.IP_value", HFILL }},
    { &hf_hi2_iP_assignment,
      { "iP-assignment", "hi2.iP_assignment",
        FT_UINT32, BASE_DEC, VALS(hi2_T_iP_assignment_vals), 0,
        "hi2.T_iP_assignment", HFILL }},
    { &hf_hi2_iPBinaryAddress,
      { "iPBinaryAddress", "hi2.iPBinaryAddress",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING_SIZE_4_16", HFILL }},
    { &hf_hi2_iPTextAddress,
      { "iPTextAddress", "hi2.iPTextAddress",
        FT_STRING, BASE_NONE, NULL, 0,
        "hi2.IA5String_SIZE_7_45", HFILL }},
    { &hf_hi2_countryCode,
      { "countryCode", "hi2.countryCode",
        FT_STRING, BASE_NONE, NULL, 0,
        "hi2.PrintableString_SIZE_2", HFILL }},
    { &hf_hi2_qosMobileRadio,
      { "qosMobileRadio", "hi2.qosMobileRadio",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING", HFILL }},
    { &hf_hi2_qosGn,
      { "qosGn", "hi2.qosGn",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING", HFILL }},
    { &hf_hi2_iri_to_CC,
      { "iri-to-CC", "hi2.iri_to_CC",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.IRI_to_CC_Correlation", HFILL }},
    { &hf_hi2_iri_to_iri,
      { "iri-to-iri", "hi2.iri_to_iri",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.IRI_to_IRI_Correlation", HFILL }},
    { &hf_hi2_both_IRI_CC,
      { "both-IRI-CC", "hi2.both_IRI_CC",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.T_both_IRI_CC", HFILL }},
    { &hf_hi2_iri_CC,
      { "iri-CC", "hi2.iri_CC",
        FT_NONE, BASE_NONE, NULL, 0,
        "hi2.IRI_to_CC_Correlation", HFILL }},
    { &hf_hi2_iri_IRI,
      { "iri-IRI", "hi2.iri_IRI",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.IRI_to_IRI_Correlation", HFILL }},
    { &hf_hi2_cc,
      { "cc", "hi2.cc",
        FT_UINT32, BASE_DEC, NULL, 0,
        "hi2.T_cc", HFILL }},
    { &hf_hi2_cc_item,
      { "cc", "hi2.cc_item",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING", HFILL }},
    { &hf_hi2_iri,
      { "iri", "hi2.iri",
        FT_BYTES, BASE_HEX, NULL, 0,
        "hi2.OCTET_STRING", HFILL }},

/*--- End of included file: packet-hi2-hfarr.c ---*/
#line 66 "packet-hi2-template.c"
  };

  /* List of subtrees */
  static gint *ett[] = {

/*--- Included file: packet-hi2-ettarr.c ---*/
#line 1 "packet-hi2-ettarr.c"
    &ett_hi2_IRIsContent,
    &ett_hi2_IRISequence,
    &ett_hi2_IRIContent,
    &ett_hi2_IRI_Parameters,
    &ett_hi2_SET_SIZE_1_10_OF_PartyInformation,
    &ett_hi2_T_callContentLinkInformation,
    &ett_hi2_CommunicationIdentifier,
    &ett_hi2_Network_Identifier,
    &ett_hi2_Network_Element_Identifier,
    &ett_hi2_TimeStamp,
    &ett_hi2_LocalTimeStamp,
    &ett_hi2_PartyInformation,
    &ett_hi2_T_partyIdentity,
    &ett_hi2_CallingPartyNumber,
    &ett_hi2_CalledPartyNumber,
    &ett_hi2_Location,
    &ett_hi2_TetraLocation,
    &ett_hi2_T_ms_Loc,
    &ett_hi2_GSMLocation,
    &ett_hi2_T_geoCoordinates,
    &ett_hi2_T_utmCoordinates,
    &ett_hi2_T_utmRefCoordinates,
    &ett_hi2_UMTSLocation,
    &ett_hi2_GeographicalCoordinates,
    &ett_hi2_GA_Point,
    &ett_hi2_GA_PointWithUnCertainty,
    &ett_hi2_GA_Polygon,
    &ett_hi2_GA_Polygon_item,
    &ett_hi2_CallContentLinkCharacteristics,
    &ett_hi2_Services_Information,
    &ett_hi2_ISUP_parameters,
    &ett_hi2_DSS1_parameters_codeset_0,
    &ett_hi2_MAP_parameters,
    &ett_hi2_Supplementary_Services,
    &ett_hi2_Standard_Supplementary_Services,
    &ett_hi2_Non_Standard_Supplementary_Services,
    &ett_hi2_Non_Standard_Supplementary_Services_item,
    &ett_hi2_Other_Services,
    &ett_hi2_ISUP_SS_parameters,
    &ett_hi2_DSS1_SS_parameters_codeset_0,
    &ett_hi2_DSS1_SS_parameters_codeset_4,
    &ett_hi2_DSS1_SS_parameters_codeset_5,
    &ett_hi2_DSS1_SS_parameters_codeset_6,
    &ett_hi2_DSS1_SS_parameters_codeset_7,
    &ett_hi2_DSS1_SS_Invoke_Components,
    &ett_hi2_MAP_SS_Invoke_Components,
    &ett_hi2_MAP_SS_Parameters,
    &ett_hi2_SMS_report,
    &ett_hi2_T_sMS_Contents,
    &ett_hi2_National_Parameters,
    &ett_hi2_Services_Data_Information,
    &ett_hi2_GPRS_parameters,
    &ett_hi2_DataNodeAddress,
    &ett_hi2_IPAddress,
    &ett_hi2_IP_value,
    &ett_hi2_National_HI2_ASN1parameters,
    &ett_hi2_UmtsQos,
    &ett_hi2_CorrelationValues,
    &ett_hi2_T_both_IRI_CC,
    &ett_hi2_IRI_to_CC_Correlation,
    &ett_hi2_T_cc,

/*--- End of included file: packet-hi2-ettarr.c ---*/
#line 71 "packet-hi2-template.c"
  };

  /* Register protocol */
  proto_hi2 = proto_register_protocol(PNAME, PSNAME, PFNAME);

  /* Register fields and subtrees */
  proto_register_field_array(proto_hi2, hf, array_length(hf));
  proto_register_subtree_array(ett, array_length(ett));

}


/*--- proto_reg_handoff_hi2 -------------------------------------------*/
void proto_reg_handoff_hi2(void) {

/*--- Included file: packet-hi2-dis-tab.c ---*/
#line 1 "packet-hi2-dis-tab.c"
  register_ber_oid_dissector("0.4.0.2.2.1.10", dissect_IRIsContent_PDU, proto_hi2, "HI2Operations");


/*--- End of included file: packet-hi2-dis-tab.c ---*/
#line 86 "packet-hi2-template.c"
  oid_add_from_string("HI2Operations","0.4.0.2.2.1.10");
}

/*
void
proto_reg_handoff_hi2(void)
{
    static gboolean inited = FALSE;
    
    if( !inited ) {
        
    hi2_handle = create_dissector_handle(dissect_hi2, proto_hi2);
    dissector_add("udp.port", global_hi2_port, hi2_handle);
    inited = TRUE;
    }
}
*/
                                                                                         